/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999 Ming Lu, computer science, cornell university
 * All rights reserved.
 *
 * This package can be used for non-profit, non-commercial
 * purpose. For any other purpose, please contact the author at 
 * ml124@cornell.edu
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*******************************
 *
 *  Test.h
 *
 *  $Id: ChannelBW.h,v 1.1 1999/05/02 00:12:19 minglu Exp $
 *  $log$
 *
 *******************************/

#ifndef ChannelBW_H
#define ChannelBW_H


class ChannelBW
{
private:
   void copy(const ChannelBW & src);
   void cleanup();
   float *channelBandwidthInternel;
   int maxChannels;
   
   
public:
   
   ChannelBW();
   ChannelBW(const ChannelBW & that);
   virtual ~ChannelBW();
   
   ChannelBW & operator=(const ChannelBW &that);
   int operator==(const ChannelBW &right);
   int operator!=(const ChannelBW &right);
   
   int getChannel(int bandwidth, int &channelNumbers, float * channelBandwidth);
   int setMaxChannels(int max);
   int getMaxChannels();
   
   
   void debug(void * p);
       
};

#endif /* ChannelBW_H */

