/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999 Ming Lu, computer science, cornell university
 * All rights reserved.
 *
 * This package can be used for non-profit, non-commercial
 * purpose. For any other purpose, please contact the author at 
 * ml124@cornell.edu
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
#include <stdio.h>
#include "SRMClient.h"
//#include "TextSRMClient.h"

#include "TestVideoClient.h"
#include "PyramidDecoder.h"
#include "VideoSRMChannelClient.h"
#include "VideoSRMClient.h"
#include "SocketServer.h"
#define TTL 16
#define MAXChannels 5


int findNoOfChannels(int bandwidth)
{
//   printf("bandwidt=%d KBPS \n",bandwidth);
   if( bandwidth<100) return 1;
   else if (bandwidth<200) return 2;
   else return 3;
}

int main(int argc, char **argv)
{

   int myPort;
   int _noOfChannels;
   
   myPort=atoi(argv[1]);
   
   char request[121];
   int multicastPort;
   char multicastIP[20];
   unsigned int multicastAddr;
   char title[100];
//   Video *videoServer;
   int bandwidth;


   
   
   
   if(argc!=2)
      {
         printf(" usage: %s portNumber\n",argv[0]);
         exit(1);
      }
   myPort=atoi(argv[1]);
   SocketServer s(myPort);

   s.accept();
       
   for(int i=0;i<120;i++) 
      {
         s.readString((char *)request+i,1);
         if(request[i]=='\n')
            {
               request[i]='\0';
               break;
            }
      }
      
   

               
//   strcpy(request,"56 4440 224.4.4.4 Real Time");
   
   sscanf(request,"%d%d%s",&bandwidth,&multicastPort,(char *)multicastIP);
   multicastAddr = (unsigned) LookupHostAddr(multicastIP);
   strcpy(title,strpbrk(request," "));
   strcpy(title,strpbrk(title+1," ")+1);
   strcpy(title,strpbrk(title+1," ")+1);
//   printf("TITLE=%s\n",title);
   _noOfChannels=findNoOfChannels(bandwidth);

       ///// to define multicast IP addrs and ports
   unsigned int * _addr;
   unsigned int * _port;
   unsigned int * _ttl;
   _addr=new int[MAXChannels];
   _port=new int[MAXChannels];
   _ttl=new int[MAXChannels];
   
   for(int i=0;i<MAXChannels;i++)
      {
         _ttl[i]=TTL;
         _port[i]=multicastPort+i;
         _addr[i]=multicastAddr;
      }
   
   VideoSRMClient client(_addr,_port,_ttl,_noOfChannels);
      TestVideoClient *videoClient;
   videoClient=new TestVideoClient;
   PyramidDecoder *decoder;
   decoder=new PyramidDecoder(_noOfChannels);

   client.setDecoder(decoder);

   videoClient->setServerSocket(&s);
   
   client.setVideoClient(videoClient);
   
   while(1)
      {
         Tcl_DoOneEvent(0);
      }

   
}
