/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999 Ming Lu, computer science, cornell university
 * All rights reserved.
 *
 * This package can be used for non-profit, non-commercial
 * purpose. For any other purpose, please contact the author at 
 * ml124@cornell.edu
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*******************************
 *
 *  LayerDecoder.cc
 *
 *  $Id: LayerDecoder.cc,v 1.1 1999/05/02 00:14:10 minglu Exp $
 *  $log$
 *
 *******************************/


#include <assert.h>
#include "LayerDecoder.h"

LayerDecoder::LayerDecoder()
{
   noOfChannels=0;
}

LayerDecoder::LayerDecoder(ChannelBW &bw)
{

   
}

LayerDecoder::LayerDecoder(const LayerDecoder & that)
{
   copy(that);
}

LayerDecoder & LayerDecoder::operator=(const LayerDecoder &that)
{
   
   if( this==&that)   // note: this is ONLY good for single inheritance
      return *this;  
   
       // IMPORTANT
       // if this is a child class of some base class Base, then do this first :
       //  Base::operator=(that);

       
   cleanup(); // in the case of inheritance, cleanup and copy can be VIRTUAL FUNCTIONS !!
   copy(that);
      
   return *this;
}

int LayerDecoder::operator==(const LayerDecoder &right)
{
   
}

int LayerDecoder::operator!=(const LayerDecoder &right)
{
   return !(operator==(right));
}

LayerDecoder::~LayerDecoder()
{
   cleanup();
}

// delete the memory used by this class
void LayerDecoder::cleanup()
{
   
}

void LayerDecoder::copy(const LayerDecoder & that)
{
   
}


void LayerDecoder::debug(void * p)
{
#ifdef DEBUG 
   assert(p);
   cerr<<__LINE__;
#endif
}


