/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999 Ming Lu, computer science, cornell university
 * All rights reserved.
 *
 * This package can be used for non-profit, non-commercial
 * purpose. For any other purpose, please contact the author at 
 * ml124@cornell.edu
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*******************************
 *
 * LayerEncoder.h
 *
 *   Abstract class for layered encoding
 *
 *  $Id: LayerEncoder.h,v 1.2 1999/05/09 18:51:30 minglu Exp $
 *  $log$
 *
 *******************************/

#ifndef LayerEncoder_H
#define LayerEncoder_H




#include "ChannelBW.h"

class LayerEncoder
{
private:
   void copy(const LayerEncoder & src);
   void cleanup();
protected:
   int noOfChannels;
   float *channelBandwidth;
   
public:
   
   LayerEncoder();
   LayerEncoder(ChannelBW & bw);
   LayerEncoder(const LayerEncoder & that);
   virtual ~LayerEncoder();
   
   LayerEncoder & operator=(const LayerEncoder &that);
   int operator==(const LayerEncoder &right);
   int operator!=(const LayerEncoder &right);
   
   void debug(void * p);

      
   virtual void encode(unsigned char *frame,int seqno,int rows,int cols,int colors,unsigned char **out,int* len)=0;

};

#endif /* LayerEncoder_H */

