/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999 Ming Lu, computer science, cornell university
 * All rights reserved.
 *
 * This package can be used for non-profit, non-commercial
 * purpose. For any other purpose, please contact the author at 
 * ml124@cornell.edu
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*******************************
 *
 *  MPEGVideo.h
 *
 *  $Id: MPEGVideo.h,v 3.0 1999/05/13 16:55:05 minglu Exp minglu $
 *  $log$
 *
 *******************************/

#ifndef MPEGVideo_H
#define MPEGVideo_H
#include "Video.h"
extern "C"
{
   
#include "io-util.h"
};


class MPEGVideo:public Video
{
private:
   void copy(const MPEGVideo & src);
   void cleanup();
   char movieName[24];
   int ifDecoded();
   int inDecoding;
   
public:
   
   MPEGVideo();
   MPEGVideo(char *filename);
   MPEGVideo(const MPEGVideo & that);
   virtual ~MPEGVideo();

   MPEGVideo & operator=(const MPEGVideo &that);
   int operator==(const MPEGVideo &right);
   int operator!=(const MPEGVideo &right);
   void debug(void * p);
   void getFrame(int seqno,unsigned char *frame, int &rows, int &cols, int &colors);
   
};

#endif /* MPEGVideo_H */

