/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999 Ming Lu, computer science, cornell university
 * All rights reserved.
 *
 * This package can be used for non-profit, non-commercial
 * purpose. For any other purpose, please contact the author at 
 * ml124@cornell.edu
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*******************************
 *
 *  PPMClient.cc
 *
 *  $Id: PPMClient.cc,v 3.0 1999/05/13 16:55:36 minglu Exp minglu $
 *  $log$
 *
 *******************************/


#include <assert.h>
#include "PPMClient.h"

PPMClient::PPMClient()
{
   
}

PPMClient::PPMClient(char *severname, int port)
{
 client=new SocketClient(severname,port);  
}

PPMClient::PPMClient(const PPMClient & that)
{
   copy(that);
}

PPMClient & PPMClient::operator=(const PPMClient &that)
{
   
   if( this==&that)   // note: this is ONLY good for single inheritance
      return *this;  
   
       // IMPORTANT
       // if this is a child class of some base class Base, then do this first :
       //  Base::operator=(that);

       
   cleanup(); // in the case of inheritance, cleanup and copy can be VIRTUAL FUNCTIONS !!
   copy(that);
      
   return *this;
}

int PPMClient::operator==(const PPMClient &right)
{
   
}

int PPMClient::operator!=(const PPMClient &right)
{
   return !(operator==(right));
}

PPMClient::~PPMClient()
{
   cleanup();
}

// delete the memory used by this class
void PPMClient::cleanup()
{
   
}

void PPMClient::copy(const PPMClient & that)
{
   
}






void PPMClient::readImage(int &_width, int &_height,int &_colors,unsigned char *image)
{
   char tmp[100];
   unsigned char *largeString;

   for(int i=0;i<100;i++)
      tmp[i]='\0';
   int lineEndCount=0;
   
   for(int i=0;i<30;i++)
      {
         
         client->readString(tmp+i,1);
         if(tmp[i]=='\n') {
            lineEndCount++;
         tmp[i]=' ';
         }
         
         if(lineEndCount==3)
            {
               tmp[i+1]='\0';
               break;
               
            }
         
      }
   
   char imgType[3];
   sscanf(tmp,"%s%d%d",imgType,&width,&height);
   
   if(strcmp(imgType,"P6")==0 || strcmp(imgType,"p6")==0)
      {
         colors=3;
      }
   else 
      {
         printf("image type is %s . Not implemented \n",tmp);
      }
   int size=width*height*colors;
   int bytesReaded=0;
   int tmptmp=0;
   do
      {
        tmptmp=client->readString((char *)(image+bytesReaded),size-bytesReaded);
        if(tmptmp<0)
           {
              printf("Something wrong ?");
           }
        else if(tmptmp>0)
           {
              bytesReaded+=tmptmp;
           }
      }
   while(size> bytesReaded);
   client->close();
   (image)[size]='\0';

   _colors=colors;
   _width=width;
   _height=height;
//   write_ppm_BYTE((unsigned char *)"testTest.ppm",image,height,width,(unsigned char *)"");
}


int PPMClient::close()
{
   client->close();
   
}
