/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999 Ming Lu, computer science, cornell university
 * All rights reserved.
 *
 * This package can be used for non-profit, non-commercial
 * purpose. For any other purpose, please contact the author at 
 * ml124@cornell.edu
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*******************************
 *
 *  PPMClient.h
 *
 *  $Id: PPMClient.h,v 1.1 1999/05/08 22:44:24 minglu Exp $
 *  $log$
 *
 *******************************/

#ifndef PPMClient_H
#define PPMClient_H

#include "socketClient.h"

class PPMClient 
{
private:
   void copy(const PPMClient & src);
   void cleanup();
   int width;
   int height;
   int colors;
   SocketClient* client;
   unsigned char *data;
   
public:
   
   PPMClient();
   PPMClient(char *severname, int port);
  
   PPMClient(const PPMClient & that);
   virtual ~PPMClient();

   PPMClient & operator=(const PPMClient &that);
   int operator==(const PPMClient &right);
   int operator!=(const PPMClient &right);
   
   void readImage(int &width, int &height,int &colors, unsigned char *image);
   int close();
   
 };

#endif /* PPMClient_H */

