/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999 Ming Lu, computer science, cornell university
 * All rights reserved.
 *
 * This package can be used for non-profit, non-commercial
 * purpose. For any other purpose, please contact the author at 
 * ml124@cornell.edu
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*******************************
 *
 *  PyramidDecoder.cc
 *
 *  $Id: PyramidDecoder.cc,v 1.6 1999/05/11 00:53:40 minglu Exp $
 *  $log$
 *
 *******************************/

#include <iostream.h>
#include <assert.h>
#include "PyramidDecoder.h"
#include "_decode.cc"

PyramidDecoder::PyramidDecoder()
{
   noOfChannels=2;
   
}
PyramidDecoder::PyramidDecoder(int _noOfChannels)
{
   noOfChannels=_noOfChannels;
   
}
PyramidDecoder::PyramidDecoder(ChannelBW &bw)
{
   noOfChannels=2;
       // list memebers in an initialization list in the order in which they are declared.
}

PyramidDecoder::PyramidDecoder(const PyramidDecoder & that)
{
   copy(that);
}

PyramidDecoder & PyramidDecoder::operator=(const PyramidDecoder &that)
{
   
   if( this==&that)   // note: this is ONLY good for single inheritance
      return *this;  
   
       // IMPORTANT
       // if this is a child class of some base class Base, then do this first :
       //  Base::operator=(that);

       
   cleanup(); // in the case of inheritance, cleanup and copy can be VIRTUAL FUNCTIONS !!
   copy(that);
      
   return *this;
}

int PyramidDecoder::operator==(const PyramidDecoder &right)
{
   
}

int PyramidDecoder::operator!=(const PyramidDecoder &right)
{
   return !(operator==(right));
}

PyramidDecoder::~PyramidDecoder()
{
   cleanup();
}

// delete the memory used by this class
void PyramidDecoder::cleanup()
{
   
}

void PyramidDecoder::copy(const PyramidDecoder & that)
{
   
}

void PyramidDecoder::debug(void * p)
{
#ifdef DEBUG 
   assert(p);
   cerr<<__LINE__;
#endif
}
// here assume there are noOfChannels of data
void PyramidDecoder::decode(unsigned char **in,
               int &rows,int &cols,int &colors,
            unsigned char **out)
{
   
   int noOfBlocks;

   int len[4];
   unsigned char *low;
   unsigned char *high[3];
   unsigned char *tmp;


   
   unpack(in[0],noOfBlocks,rows,cols,colors,&low,len);

   
   if(noOfBlocks!=1)
      {
         printf("Error noOfBlocks should be 1\n");
      }
       
   if(noOfChannels>1)
      {
         int size;
         size=rows*cols*colors;
         for(int i=0;i<noOfChannels-1;i++)
            size<<=2;
         tmp=new (unsigned char)[size];
         
         for(int i=0;i<noOfChannels-1;i++)
            {
               unpack(in[i+1],noOfBlocks,rows,cols,colors,high,len);
               if(noOfBlocks!=3)
                  {
                     printf("Error noOfBlocks should be 3\n");
                  }
               rows<<=1;
               cols<<=1;
               
               _decodeOnce(rows,cols,colors,tmp,low,high[0],high[1],high[2]);
                   //             delete[] low;
               low=tmp;
//               memcpy(low,tmp,rows*cols);
               
            }
      }
      

   *out=low;




















/***
   if(colors==1)
      write_pgm_BYTE("_decode.pgm",low,rows,cols,(unsigned char *)"");
   else write_ppm_BYTE("_decode.ppm",low,rows,cols,(unsigned char *)"");
   *****/
   
}


