/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999 Ming Lu, computer science, cornell university
 * All rights reserved.
 *
 * This package can be used for non-profit, non-commercial
 * purpose. For any other purpose, please contact the author at 
 * ml124@cornell.edu
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*******************************
 *
 *  PyramidDecoder.h
 *
 *  $Id: PyramidDecoder.h,v 1.2 1999/05/11 00:53:08 minglu Exp $
 *  $log$
 *
 *******************************/

#ifndef PyramidDecoder_H
#define PyramidDecoder_H

#include "ChannelBW.h"
#include "LayerDecoder.h"
class PyramidDecoder:public LayerDecoder
{
private:
   void copy(const PyramidDecoder & src);
   void cleanup();
   
public:
   
   PyramidDecoder();
     
   PyramidDecoder(int _noOfChannels);
   PyramidDecoder(ChannelBW &bw);

   PyramidDecoder(const PyramidDecoder & that);
   virtual ~PyramidDecoder();

   PyramidDecoder & operator=(const PyramidDecoder &that);
   int operator==(const PyramidDecoder &right);
   int operator!=(const PyramidDecoder &right);


   
   void debug(void * p);
   void decode(unsigned char **in,
               int &rows,int &cols,int &colors,
               unsigned char **out);
   
};

#endif /* PyramidDecoder_H */

