/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999 Ming Lu, computer science, cornell university
 * All rights reserved.
 *
 * This package can be used for non-profit, non-commercial
 * purpose. For any other purpose, please contact the author at 
 * ml124@cornell.edu
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*******************************
 *
 *  PyramidEncoder.cc
 *
 *  $Id: PyramidEncoder.cc,v 3.0 1999/05/13 16:55:36 minglu Exp minglu $
 *  $log$
 *
 *******************************/

#include <iostream.h>
#include <assert.h>
#include "PyramidEncoder.h"
#include "_encode.cc"




/*******************/

PyramidEncoder::PyramidEncoder()
{
  noOfChannels=2;
    
}
PyramidEncoder::PyramidEncoder(int _noOfChannels)
{
  noOfChannels=_noOfChannels;
    
}
PyramidEncoder::PyramidEncoder(ChannelBW &bw)
{
// Tempary use 2 for noOfChannels
   noOfChannels=2;
   
}

PyramidEncoder::PyramidEncoder(const PyramidEncoder & that)
{
   copy(that);
}

PyramidEncoder & PyramidEncoder::operator=(const PyramidEncoder &that)
{
   
   if( this==&that)   // note: this is ONLY good for single inheritance
      return *this;  
   
       // IMPORTANT
       // if this is a child class of some base class Base, then do this first :
       //  Base::operator=(that);

       
   cleanup(); // in the case of inheritance, cleanup and copy can be VIRTUAL FUNCTIONS !!
   copy(that);
      
   return *this;
}

int PyramidEncoder::operator==(const PyramidEncoder &right)
{
   
}

int PyramidEncoder::operator!=(const PyramidEncoder &right)
{
   return !(operator==(right));
}

PyramidEncoder::~PyramidEncoder()
{
   cleanup();
}

// delete the memory used by this class
void PyramidEncoder::cleanup()
{
   
}

void PyramidEncoder::copy(const PyramidEncoder & that)
{
   
}


void PyramidEncoder::debug(void * p)
{
#ifdef DEBUG 
   assert(p);
   cerr<<__LINE__;
#endif
}

void PyramidEncoder::encode(unsigned char *frame,int seqno,int rows,int cols,int colors,unsigned char **out,int* len)
{
   
   unsigned char *src=frame;
   int width,height;
   width=cols;
   height=rows;
   int tmpLen[2];

   struct _PyramidInfo *info;
   info=new (struct _PyramidInfo)[noOfChannels];

   

  
   
   for(int i=noOfChannels-1;i>0;i--)
      {

         _encodeOnce(src,height,width,colors,&info[i-1],&info[i]);
         
         src=info[i-1].data;

         height>>=1;
         width>>=1;
      }
       
   for (int i=0;i<noOfChannels;i++)
      {

         cout<<"len["<<i<<"]="<<info[i].length <<endl;
      }

 for(int i=0;i<noOfChannels;i++)
    {
       if(info[i].noOfBlocks==1)
             sprintf(out[i],"%d %d %d %d %d %d %d ",i,seqno,info[i].noOfBlocks,info[i].width,info[i].height,info[i].colors,info[i].len[0]);
       else
          sprintf(out[i],"%d %d %d %d %d %d %d %d %d ",i,seqno,info[i].noOfBlocks,info[i].width,info[i].height,info[i].colors,info[i].len[0],info[i].len[1],info[i].len[2]);
       for(int k=0;k<50;k++)
          {
             if(out[i][k]=='\0')
                out[i][k]=' ';
          }
       
       memcpy(out[i]+50,info[i].data,info[i].length);

       
       len[i]=50+info[i].length+1;
       
    }

}
