/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999 Ming Lu, computer science, cornell university
 * All rights reserved.
 *
 * This package can be used for non-profit, non-commercial
 * purpose. For any other purpose, please contact the author at 
 * ml124@cornell.edu
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
#ifndef PYRAMID_PACK_CC
#define PYRAMID_PACK_CC
#include <stdio.h>

void pack(int noOfBlocks,int rows, int cols, int colors, int *len, unsigned char **in, unsigned char **out, int &sizeOut)
{
   int size=0;
   for( int i=0;i<noOfBlocks;i++)
      {
         size+=len[i];
      }
   *out=new (unsigned char )[size+sizeof(int)*6+10];
   sprintf(*out," %d %d %d %d ",noOfBlocks,rows,cols,colors);
   
   for(int i=0;i<noOfBlocks;i++)
      sprintf(*out,"%s%d ",*out,len[i]);
   
   for(int i=0;i<noOfBlocks;i++)
      {
         
//      sprintf(*out,"%s ",in[i]);
         strcat(*out,in[i]);
         strcat(*out," ");
         
      }
   sizeOut=strlen(*out);
   
}
void unpack(unsigned char *in,int &noOfBlocks,int &rows, int &cols, int &colors, unsigned char **out, int *len )
{
//   sscanf(in,"%d%d%d%d",&noOfBlocks,&cols,&rows,&colors);
//   *len=new int[noOfBlocks];
   


   printf("222222222222222222\n");
   int channelID,seqNo;
   unsigned char tmp[51];   
   memcpy(tmp,in,50);
   tmp[50]='\0';
   sscanf(tmp,"%d%d%d%d%d%d%d",&channelID,&seqNo,&noOfBlocks,&cols,&rows,&colors,&len[0]);

   if(noOfBlocks==3)
      {
         sscanf(tmp,"%d%d%d%d%d%d%d%d%d",&channelID,&seqNo,&noOfBlocks,&cols,&rows,&colors,&len[0],&len[1],&len[2]);
      }
   int t=50;
   
   for(int i=0;i<noOfBlocks;i++)
      {
         out[i]=in+t;
         t+=len[i];
      }
   

       /***
   for(int i=0;i<noOfBlocks+4;i++)
      {
         sscanf(tmpIn,"%d",&tmp[i]);
         tmpIn=strpbrk(tmpIn+1," ");
      }
   for(int i=0;i<noOfBlocks;i++)
      len[i]=tmp[i+4];
   unsigned char *t;
   tmpIn++;
   
   for(int i=0;i<noOfBlocks;i++)
      {
         out[i]=tmpIn;
         tmpIn=out[i]+len[i];
         out[i][(len[i])]='\0';
      }

      ***/
   printf("222222222222222222222222222222222222222222\n");
}

/***************************
main()
{
   unsigned char *out,**in;

   in=new (unsigned char *)[3];
   for(int i=0;i<3;i++)
      {
         in[i]=new (unsigned char)[20];
      }
   strcpy(in[0],"Hello World!");
   strcpy(in[1],"Good Morning!");
   strcpy(in[2],"How are you?");

   int len[3];
   int sizeOut;
   
      for(int i=0;i<3;i++)
      {
         len[i]=strlen(in[i]);
      }

      pack(3,100,200,1,len,in,&out,sizeOut);
      printf("sizeOut=%d\n",sizeOut);
      printf("%s\n",out);
      printf("-------------------\n");
      
      int noOfBlocks, rows,cols,colors;
     
      unpack(out,noOfBlocks,rows, cols, colors,in,len);
      printf("noOfBlocks=%d rows=%d cols=%d colors=%d\n",noOfBlocks,rows,cols,colors);
      for(int i=0;i<noOfBlocks;i++)
         printf(" len[%d]=%d  %s\n",i,len[i],in[i]);

}

***************************/
#endif




