/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999 Ming Lu, computer science, cornell university
 * All rights reserved.
 *
 * This package can be used for non-profit, non-commercial
 * purpose. For any other purpose, please contact the author at 
 * ml124@cornell.edu
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

import java.net.*;
import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.image.*;

public class RTVideoSever extends AbsVideoSever 
{
protected PrintStream out;
protected InputStream in;
protected PrintStream err;
       
   static final String progName = "RTVideoSever";

    // Old-style main() routine.  Calls compatibility routine for newMain().
public   RTVideoSever()
         {
            }
         
            
   public  void fetchImage(String urlName,int seqNo,OutputStream _out)
        {
           in=System.in;
           err=System.err;
           out=new PrintStream(_out);
           dump( urlName );           
        }


    // Got to make one of these even if we don't use it, cause it loads
    // in some necessary native methods.
//    private Toolkit tk = new Acme.JPM.StubToolkit();

    private void dump( String urlStr )
	{
	try
	    {
           System.out.println("4444444");
	    URL url = new URL( urlStr );
	    URLConnection uc = url.openConnection();
        System.out.println("5555555");
	    uc.connect();
        System.out.println("36666666");
	    // Got to open a stream to get around Java NullPointerException bug.
	    InputStream f = uc.getInputStream();
        System.out.println("3333333333");
	    String mimeType = uc.getContentType();
        System.out.println("111111111");
        
	    // Java prints (not throws!) a ClassNotFoundException if you try
	    // a getContent on text.html or audio/basic (or no doubt many
	    // other types).
	    if ( ! mimeType.startsWith( "image/" ) )
		err.println( progName + ": " + urlStr + " is not an image" );
	    else
		{
		Object content = uc.getContent();
		if ( ! ( content instanceof ImageProducer ) )
		    err.println(progName + ": " + urlStr +" is not a known image type" );
		else
		    {
               System.out.println("2222222");
		    ImageProducer prod = (ImageProducer) content;
		    Acme.JPM.Encoders.ImageEncoder ie =
			new Acme.JPM.Encoders.PpmEncoder( prod, out );
            System.out.println(" before ie.encode() ...");
            
		    ie.encode();
            //      f.close();
                   // out.close();
            
            System.out.println(" after ie.encode() ...");

            
            
		    }
		}

	    // Done with unnecessary stream.
	    f.close();
	    }
	catch ( Exception e )
	    {
	    err.println( progName + ": " + e );

        
	    }
	}

    }
