/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999 Ming Lu, computer science, cornell university
 * All rights reserved.
 *
 * This package can be used for non-profit, non-commercial
 * purpose. For any other purpose, please contact the author at 
 * ml124@cornell.edu
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import java.applet.*;
			
public class Regist extends Frame implements ActionListener{
	TextArea textarea;      
	TextField theField = new TextField(10);
	final static int thePort = 1234;
	Socket theSocket;
	BufferedReader in;
	PrintWriter out;
	String input,S;
	String inputChoice="Real Time";
   static int SRMClientPort;
   static String SRMClientHost=null;
   static int fps;
   String bandWidth="56";
   
	//String inputCheckBox="56Kbps";
	public Regist(String title)
	{
		super(title);//sets frame title
		//windows close events
		this.addWindowListener(new WindowAdapter(){
			public void WindowClosing(WindowEvent e){
				System.exit(0);}
			});
		//Default font
		this.setFont(new Font("SansSerif", Font.PLAIN, 11));
		//Create Menu Bar
	    MenuBar menubar= new MenuBar();
		this.setMenuBar(menubar);
		//Create Help Menu and add to menubar
		Menu help = new Menu("Help");
		menubar.add(help);
		menubar.setHelpMenu(help);
		
		//Create and Add Item to Help Menu
		MenuItem about =new MenuItem("About", new MenuShortcut(KeyEvent.VK_A));
		about.setActionCommand("about");
		about.addActionListener(this);
		help.add(about);
		
		//Layout manager
		this.setLayout(new BorderLayout (10,10));
		//2 panels to containtwo column of components
		Panel column1 = new Panel();
		column1.setLayout(new ColumnLayout(5, 10, 2, ColumnLayout.LEFT));
		this.add(column1,"West");
		Panel column2 = new Panel();
		column2.setLayout(new ColumnLayout(5, 10, 2, ColumnLayout.LEFT));
		this.add(column2,"Center");
		
		//Create 2 panels to contain the buttons and the selections
		Panel buttonbox = new Panel();
		buttonbox.setLayout(new FlowLayout(FlowLayout.CENTER,100,10));
		this.add(buttonbox, "South");
		
		//Create  pushbottons and add them to buttonbox
		Button submit= new Button("Submit");
        Button Quit= new Button("Quit");
		submit.setActionCommand("submit");
		submit.addActionListener(this);
		Quit.setActionCommand("Quit");
		Quit.addActionListener(this);
		buttonbox.add(submit);
		buttonbox.add(Quit);
		
		//Create dropdown list of movies...Later make this dynamic to select from a file
		Choice choice = new Choice();
		choice.addItem("Real Time");
		choice.addItem("My wish");
		choice.addItem("God bless you");
		column1.add(new Label("Select a Movie:"));
		column1.add(choice);
		//*******************************************************************
		//column1.add(theField);
		//Handle events on this choice
		choice.addItemListener(new ItemListener(){
			public void itemStateChanged(ItemEvent e){
				textarea.append("The movie you selected is: " + e.getItem() + "\n");
				inputChoice = new String((String)e.getItem());
				if(inputChoice.compareTo("")==0)
					inputChoice="Real Time";
			}
			});
		
		//Create Checkboxes grouped into radio button for the banddwidth
		CheckboxGroup checkbox_group = new CheckboxGroup();
		Checkbox[] checkboxes = new Checkbox[3];
		checkboxes[0]= new Checkbox("56Kbps--Modem", checkbox_group, true);
		checkboxes[1]= new Checkbox("128Kbps--ISDN", checkbox_group, false);
		checkboxes[2]= new Checkbox("1.5MB", checkbox_group, false);
		column1.add(new Label("Select Bandwidth supported:"));
		for(int i=0; i<checkboxes.length;i++) 
			column1.add(checkboxes[i]);
		//Handle events on checkboxes
		ItemListener checkbox_listener = new ItemListener(){
			public void itemStateChanged(ItemEvent e){
				textarea.append("You selected the following Bandwidth: "+ ((Checkbox)e.getItemSelectable()).getLabel() + "\n");
                bandWidth=((Checkbox)e.getItemSelectable()).getLabel();
                if(bandWidth.compareTo("56Kbps--Modem")==0)
                   bandWidth="56";
                else if(bandWidth.compareTo("128Kbps--ISDN")==0) bandWidth="128";
                else bandWidth="1500";
                
                System.out.println("**** bandwidth selected :" +bandWidth+"\n");
                
	           // inputCheckBox=new String("");
				//inputCheckBox=inputCheckBox.concat(((Checkbox)e.getItemSelectable()).getLabel());
			    //if(inputCheckBox.compareTo("")==0)
				//	inputCheckBox="56Kbps--Modem";
			}
			};
		
		for(int i=0; i<checkboxes.length;i++) 
			checkboxes[i].addItemListener(checkbox_listener);
		//Create Multi line text are in column2
		textarea = new TextArea(6,40);
		textarea.setEditable(false);
		column2.add(new Label("Messages"));
		column2.add(textarea);
		
		//Create scrollpane
		ScrollPane scrollpane = new ScrollPane();
		scrollpane.setSize(300,150);
        column2.add(new Label("Scrolling Window"));
		column2.add(scrollpane);
		//******************************************
		column2.add(theField);
		theField.setVisible(false);
		
		//Create Label to display in the ScrollPaneContainer
		String Message=
		"/************************************************************\n"+
		"*Video On Demand REGISTRATION                   \n"+
        "*Copyright (c) 1999  Cornell University CS Dept.             \n"+
		"*                                                            \n"+
		"************************************************************/\n";
		MultiLineLabel biglabel = new MultiLineLabel(Message, 20, 20,0);
		biglabel.setFont(new Font("Monospaced", Font.BOLD + Font.ITALIC, 24));
		scrollpane.add(biglabel);
		//Try to connect to server on  port 1234
		try{
			String host = "127.0.0.1";
			theSocket = new Socket(host, thePort);
			in =new BufferedReader(new InputStreamReader(theSocket.getInputStream()));
			out =new PrintWriter(new OutputStreamWriter(theSocket.getOutputStream()), true);
			//*****************************************************************
			theField.addActionListener(this);
		}
		catch(IOException io)
		{
			System.err.println("IOException:\n" + io);
		}
		//Add Messages Received from the server to the Message area
	}
	
//This reads input in server and sends it to Client. It is called on the server side.
   void startWebcam(int fps,String _SRMClientHost,int _SRMClientPort,String movieInfo)
         {
            System.out.println(" startWebcam is called \n");
            
            try
               {
                  
            Socket webcamClient=new Socket("ringding",10000);
            PrintWriter outToWebcam=new PrintWriter(new OutputStreamWriter(webcamClient.getOutputStream()),true);
            outToWebcam.println(bandWidth+" "+movieInfo);
            System.out.println("Sent to the SRMSever successfully!");
            webcamClient.close();
            outToWebcam=null; 
               }
            catch( java.io.IOException e)
               {
                  System.out.println("Error in send movieInfo to Webcam");
                  
               }
            
            }
   
	public void start()
{
   int tmp=0;
   
	try
	{
		while(true)
		{
			String s = in.readLine();
			if( s !=null)
               {
                  tmp++;
                  if(tmp==2)
                     {
                        
                  System.out.println(s);
                      
                  startWebcam(fps,SRMClientHost,SRMClientPort,s);
                  
                     }
                  
            textarea.append(s + '\n');                              

               }

		}
	}
	catch (IOException io)
	{
		System.err.println("IOEception:\n" + io);
	}
}
	
	public void actionPerformed(ActionEvent e){
		//String line;
		String command =e.getActionCommand();
		if(command.equals("about")){
			InfoDialog d = new InfoDialog(this, "About",
												"This Demo was written by Richard Afanuh & Ming Lu\n" +
												"CS542-Cornell University 1999");
			d.show();
		}
		if (command.equals("Quit")){
			System.exit(1);
		}
		
		if(command.equals("submit")){	
				input=new String(inputChoice);
				theField=new TextField(input);
				out.println( theField.getText() );
				input=new String("");
				//Try to print message from server
				start();
		}
		
	}
	
	public static void main(String[] args){
       if(args.length==0)
          {
             System.out.println(" usage: java Regis fps SRMClientHost SRMClientPort \n");
             System.exit(1);
             
          }
       fps=20;
       SRMClientHost=args[0];
       SRMClientPort=Integer.parseInt(args[1]);
		Frame f = new Regist("NETFLICK Inc. REGISTRATION DEMO");
		f.pack();
		f.show();
	}
}


class InfoDialog extends Dialog{
	protected Button button;
	protected MultiLineLabel label;
	
	public InfoDialog(Frame parent, String Title, String message){
		super(parent,Title,false);
		this.setLayout(new BorderLayout(15,15));
		label = new MultiLineLabel(message, 20, 20,0);
		this.add("Center", label);
		button = new Button("okay");
		Panel p = new Panel();
		p.setLayout(new FlowLayout(FlowLayout.CENTER, 15, 15));
		p.add(button);
		this.add("South",p);
		this.pack();
	}
	public boolean action(Event e, Object arg){
		if(e.target == button){
			this.hide();
			this.dispose();
			return true;
		}
		else return false;
	}
	public static void main(String[] args){
	Frame f= new Frame("InfoDialog Test");
		f.resize(100,100);
		f.show();
		InfoDialog d = new InfoDialog(f, "InfoDialog Test",
								"This Demo written by Richard Afanuh & Ming Lu\n"+
								"CS542 Cornell University-1999");
		d.show();
			}
}


 class MultiLineLabel extends Canvas{
	protected String label;
	protected int margin_width;
	protected int margin_height;
	protected int alignment;
	public static final int LEFT = 0,CENTER = 1,RIGHT = 2;
	protected int num_lines;
	protected String[] lines;
	protected int[] line_widths;
	protected int max_width;
	protected int line_height;
	protected int line_ascent;
	protected boolean measured = false;
	
	public MultiLineLabel(String label, int margin_width, int margin_height, int alignment){
		this.label = label;
		this.margin_width = margin_width;
		this.margin_height = margin_height;
		this.alignment = alignment;
		newLabel();
		//this(label, margin_width,margin_height,LEFT);
	}
	
	public void setLabel(String label){
	this.label = label;
		newLabel();
		measured = false;
		repaint();
	}
	
	public void setFont(Font f){
	measured = false;
	repaint();
	}
	
	public void setForeground(Color c){
	super.setForeground(c);
	repaint();
	}
	
	public void setAlignment(int a){alignment =a; repaint();}
	public void setMarginWidth(int mw){margin_width =mw; repaint();}
	public void setMarginHeight(int mh){margin_height =mh; repaint();}
	public String getLabel(){ return label;}
	public int getAlignment(){return alignment;}
	public int getMarginWidth(){return margin_width;}
	public int getMarginHeight(){return margin_height;}
	
	
	public Dimension preferredSize(){
	if(!measured) measure();
		return new Dimension(max_width + 2*margin_width, num_lines*line_height + 2*margin_height);
	}
	public Dimension minimumSize(){return preferredSize();}
	
	public void paint(Graphics g){
	int x,y;
		Dimension size = this.size();
		if(!measured) measure();
		y = line_ascent + (size.height - num_lines * line_height)/2;
		for(int i = 0;i<num_lines; i++, y+=line_height){
			switch(alignment){
			default:
			case LEFT: x=margin_width; break;
			case CENTER: x=(size.width - line_widths[i])/2;break;
			case RIGHT: x = size.width - margin_width - line_widths[i];break;
			}
			g.drawString(lines[i],x,y);
		}
	}
	
	protected synchronized void newLabel(){
								 StringTokenizer t = new StringTokenizer(label,"\n");
								 num_lines = t.countTokens();
								 lines = new String[num_lines];
								 line_widths = new int[num_lines];
								 for (int i = 0; i < num_lines; i++) lines[i] = t.nextToken();
	}
	
	protected synchronized void measure(){
		FontMetrics fm = this.getToolkit().getFontMetrics(this.getFont());
		line_height = fm.getHeight();
		line_ascent = fm.getAscent();
		max_width = 0;
		for( int i =0; i < num_lines; i++){
			line_widths[i] = fm.stringWidth(lines[i]);
			if(line_widths[i] > max_width) max_width = line_widths[i];
		}
		measured =true;
   }
}



class ColumnLayout implements LayoutManager2{
protected int margin_height;
protected int margin_width;
protected int spacing;
protected int alignment;

public static final int LEFT=0;
public static final int CENTER=1;
public static final int RIGHT=2;

public ColumnLayout(int magin_height, int margin_width,int spacing, int alignment)
{
this.margin_height=margin_height;
this.margin_width=margin_width;
this.spacing=spacing;
this.alignment=alignment;
}

public ColumnLayout(){ this(5,5,5,LEFT);}

public void layoutContainer(Container parent){
Insets insets = parent.getInsets();
Dimension parent_size = parent.getSize();
Component kid;
int nkids = parent.getComponentCount();
int x0 =insets.left + margin_width;
int x;
int y=insets.top + margin_height;

for(int i=0; i<nkids;i++){
kid = parent.getComponent(i);
if(!kid.isVisible()) continue;
Dimension pref = kid.getPreferredSize();
switch(alignment){
default:
case LEFT: x = x0; break;
case CENTER: x = x0 +(parent_size.width-pref.width)/2;break;
case RIGHT: x = parent_size.width-insets.right-margin_width-pref.width;break;
}
kid.setBounds(x,y,pref.width,pref.height);
y+=pref.height + spacing;
}
}

public Dimension preferredLayoutSize(Container parent){
return layoutSize(parent,1);
}

public Dimension minimumLayoutSize(Container parent){
return layoutSize(parent,2);
}


public Dimension maximumLayoutSize(Container parent){
return layoutSize(parent,3);
}

protected Dimension layoutSize(Container parent, int sizetype){
int nkids =parent.getComponentCount();
Dimension size = new Dimension(0,0);
Insets insets = parent.getInsets();
int num_visible_kids =0;

for(int i =0;i<nkids;i++){
Component kid = parent.getComponent(i);
Dimension d;
if(!kid.isVisible()) continue;
num_visible_kids++;
if(sizetype == 1) d=kid.getPreferredSize();
else if(sizetype == 2) d=kid.getMinimumSize();
else d=kid.getMaximumSize();
if(d.width> size.width) size.width = d.width;
size.height +=d.height;
}
size.width +=insets.left + insets.right + 2*margin_width;
size.height +=insets.top + insets.bottom + 2*margin_height;
if(num_visible_kids>1)
size.height +=(num_visible_kids - 1)*spacing;
return size;
}
public void addLayoutComponent(String constraint, Component comp){}
public void addLayoutComponent( Component comp,Object constraint){}
public void removeLayoutComponent(Component comp){}
public void invalidateLayout(Container parent){}
public float getLayoutAlignmentX(Container parent) {return 0.5f;}
public float getLayoutAlignmentY(Container parent) {return 0.5f;}
}


    
