/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999 Ming Lu, computer science, cornell university
 * All rights reserved.
 *
 * This package can be used for non-profit, non-commercial
 * purpose. For any other purpose, please contact the author at 
 * ml124@cornell.edu
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*******************************
 *
 *  SRMChannelClient.cc
 *
 *  $Id: SRMChannelClient.cc,v 2.2 1999/05/08 22:43:35 minglu Exp $
 *  $log$
 *
 *******************************/

#include <stdio.h>
#include "SRMChannelClient.h"

SRMChannelClient::SRMChannelClient()
{
}

SRMChannelClient::SRMChannelClient(unsigned int _addr,
                     unsigned int _port,
                     unsigned int _ttl)

{
   init(_addr,_port,_ttl);
}

void SRMChannelClient::init(unsigned int _addr,
                     unsigned int _port,
                     unsigned int _ttl)

{
   addr=_addr;
   port=_port;
   ttl=_ttl;

   session = srm_create_session(addr, port, port, ttl);
   srm_set_drop_probability(session, 0.2);
   source = srm_create_source(session, NULL);

   
}
void SRMChannelClient::setCallbacks(srm_callbacks &callbacks)
{
  
   srm_set_callbacks(session, &callbacks);
         
}

void SRMChannelClient::cleanup()
{

}


SRMChannelClient::~SRMChannelClient()
{
   cleanup();
}

void  SRMChannelClient::decipher(srm_source_t _source,int cid, int &channelID, int & seqNo)
{
   unsigned char dataName[30];
   char  *p;
   const unsigned char *cname;
   int l;
   
   strcpy(dataName, "");
   p = dataName + strlen(dataName);
   while (cid != SRMv2_ROOT_CID) {
      srm_get_container_name(_source, cid, &cname, NULL);
      
      char **cnames;
      int cc;
      Tcl_SplitPath(cname, &cc, &cnames);
                char *comp = cnames[cc-1];

                if (*p) {
                        l = strlen(comp);
                        memmove(p+l+1, p, strlen(p)+1);
                        memmove(p, comp, l);
                        *(p+l) = '-';
                } else {
                        strcpy(p, comp);
                }
                Tcl_Free((char *)cnames);
                cid = srm_get_parent_cid(_source, cid);
        }

//   srm_get_container_name(source[0], cid, &cname, NULL);

   
   for(int i=strlen(dataName);i>=0;i--)
      {
         if(dataName[i]=='-') {
            
         sscanf(dataName+i+1,"%d",&seqNo);
         dataName[i]='\0';
         }
      }  
   sscanf(dataName,"%d",&channelID);
//   printf("channelID=%d seqNo=%d \n",channelID,seqNo);


   
}
void  SRMChannelClient::decipher(int cid, int &channelID, int & seqNo)
{
   decipher(source,cid,channelID,seqNo);
   
}



int SRMChannelClient::encodeCid(srm_source_t _source,int seqNo,int channelID)
{
 int cid=SRMv2_ROOT_CID;
//   cid = srm_calloc(source[channelNo], cid, (unsigned char *)videoName, strlen((const char *)videoName)+1);
   char tmpString[20];
   sprintf(tmpString,"%d",channelID);
   cid = srm_calloc(_source, cid , (const unsigned char *)tmpString, strlen(tmpString)+1);
   sprintf(tmpString,"%d",seqNo);
   cid = srm_calloc(_source, cid , (const unsigned char *)tmpString, strlen(tmpString)+1);
   return cid;
   
}


int SRMChannelClient::encodeCid(int seqNo,int channelID)
{
   return encodeCid(source,seqNo,channelID);
   
}
