/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999 Ming Lu, computer science, cornell university
 * All rights reserved.
 *
 * This package can be used for non-profit, non-commercial
 * purpose. For any other purpose, please contact the author at 
 * ml124@cornell.edu
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*******************************
 *
 *  SRMChannelClient.h
 *
 *  $Id: SRMChannelClient.h,v 2.1 1999/05/06 20:58:00 minglu Exp $
 *  $log$
 *
 *******************************/



#ifndef SRMChannelClient_H
#define SRMChannelClient_H
#include <unistd.h>
#include <string.h>
#include <sys/stat.h>
#include <glob.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>

#include "srmv2-api.h"
#include <tcl.h>


class SRMChannelClient
{
   
protected:
   int addr;
   int port;
   int ttl;
   
   srm_session_t session;
   srm_source_t source;


   
public:
   
   SRMChannelClient();
   SRMChannelClient(unsigned int _addr,
                    unsigned int _port,
                    unsigned int _ttl);
   

   void init(unsigned int _addr,
             unsigned int _port,
             unsigned int _ttl);
   
   void setCallbacks(srm_callbacks &callbacks);

   int encodeCid(int seqNo,int channelID);
   void decipher(int cid,int &channelID, int &seqNo);
   int encodeCid(srm_source_t _source,int seqNo,int channelID); 
   static void decipher(srm_source_t _source,int cid,int &channelID, int &seqNo);

   void static cleanup();
   virtual ~SRMChannelClient();
   
};



#endif
