/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999 Ming Lu, computer science, cornell university
 * All rights reserved.
 *
 * This package can be used for non-profit, non-commercial
 * purpose. For any other purpose, please contact the author at 
 * ml124@cornell.edu
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*******************************
 *
 *  SRMChannelSever.h
 *
 *  $Id: SRMChannelSever.h,v 3.0 1999/05/13 16:55:05 minglu Exp minglu $
 *  $log$
 *
 *******************************/



#ifndef SRMChannelSever_H
#define SRMChannelSever_H
#include <unistd.h>
#include <string.h>
#include <sys/stat.h>
#include <glob.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>

#include "../srmv2/srmv2-api.h"
#include <tcl.h>

class SRMChannelSever
{
protected:
   int addr;
   int port;
   int ttl;
   
   srm_session_t session;
   srm_source_t source;
   int cid;
   int firstTime;
   int base;
   
   int cidStepSize;
   
public:
   
   SRMChannelSever();
   SRMChannelSever(unsigned int _addr,
                   unsigned int _port,
                   unsigned int _ttl
                   );
   
    void init(unsigned int _addr,
                    unsigned int _port,
                    unsigned int _ttl
                    );
   
      

   void setCallbacks(srm_callbacks &callbacks);
 
   void cleanup();
   virtual ~SRMChannelSever();
   
   void sendData(srm_source_t _source,int channelID, int seqNo, unsigned char *data, int len);
   
   void sendData(int channelID, int seqNo, unsigned char *data, int len);
   
   int encodeCid(srm_source_t _source,int seqNo,int channelID); 
    void decipher(srm_source_t _source,int cid,int &channelID, int &seqNo);

   int encodeCid(int seqNo,int channelID);
   void decipher(int cid,int &channelID, int &seqNo);

};
#endif
