/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999 Ming Lu, computer science, cornell university
 * All rights reserved.
 *
 * This package can be used for non-profit, non-commercial
 * purpose. For any other purpose, please contact the author at 
 * ml124@cornell.edu
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*******************************
 *
 *  SRMClient.h
 *
 *  $Id: SRMClient.h,v 1.4 1999/05/02 00:12:19 minglu Exp $
 *  $log$
 *
 *******************************/



#ifndef SRMClient_H
#define SRMClient_H
#include <unistd.h>
#include <string.h>
#include <sys/stat.h>
#include <glob.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>

#include "srmv2-api.h"
#include <tcl.h>


class SRMClient
{
private:
   static unsigned int addr;
   static unsigned int port;
   static unsigned int ttl;

   
   static char **dataReceived;
   static int *lenReceived;
   static int *seqnoReceived;
   static float *bandwidth;
protected:
   
   static srm_session_t *session;
   static srm_source_t *source;
   static int noOfChannels;
protected:
   static   void setDataReceived(int channelNo,
                                 const unsigned char * _dataReceived,
                                 int _len,
                                 int _seqno);
   static   char *getDataReceived(int channelNo);
   static   int getLenReceived(int channelNo);
   static   int getSeqnoReceived(int channelNo);
   
public:
   
   SRMClient();
   SRMClient(unsigned int _addr,
             unsigned int _port,
             unsigned int _ttl,
             int _noOfChannels);
   static void init(unsigned int _addr,
             unsigned int _port,
             unsigned int _ttl,
             int _noOfChannels);
   static void setProbability(int channelNo,float probabability);
   static void setCallbacks(srm_callbacks &callbacks);
   
   static void setNoOfChannels(int no);
   static void setBandwidth(int *_bandwidth);
   void static cleanup();
   virtual ~SRMClient();

   static int findChannelNo(srm_source_t  _source,int cid,char *dataName);
   
};



#endif
