/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999 Ming Lu, computer science, cornell university
 * All rights reserved.
 *
 * This package can be used for non-profit, non-commercial
 * purpose. For any other purpose, please contact the author at 
 * ml124@cornell.edu
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*******************************
 *
 *  SRMSever.cc
 *
 *  $Id: SRMSever.cc,v 1.3 1999/04/11 21:58:46 minglu Exp $
 *  $log$
 *
 *******************************/


#include <strings.h>
#include "SRMSever.h"
#include <stdio.h>

unsigned int SRMSever::addr;
unsigned int SRMSever::port;
unsigned int SRMSever::ttl;
int SRMSever::noOfChannels;
unsigned char **SRMSever::channelData;
int *SRMSever::len;
float *SRMSever::bandwidth;
srm_session_t *SRMSever::session;
srm_source_t *SRMSever::source;
int SRMSever::seqno;

SRMSever::SRMSever()
{
}

SRMSever::SRMSever(unsigned int _addr,
                     unsigned int _port,
                     unsigned int _ttl,
                   int _noOfChannels)
{
   init(_addr,_port,_ttl,_noOfChannels);
}

void SRMSever::init(unsigned int _addr,
                     unsigned int _port,
                     unsigned int _ttl,
                   int _noOfChannels)   
{
   addr=_addr;
   port=_port;
   ttl=_ttl;
   noOfChannels=_noOfChannels;

   seqno=0;
   
   channelData=new (unsigned char *)[noOfChannels];
   len=new int[noOfChannels]; 
   bandwidth=new float[noOfChannels];
   
       // allocate channels
   session=new srm_session_t [noOfChannels];
   source=new srm_source_t[noOfChannels];

   
   for(int i=0;i<noOfChannels;i++)
      {
         session[i] = srm_create_session(addr, port, port, ttl);
         source[i] = srm_create_source(session[i], NULL);

      }

   
}

void SRMSever::setCallbacks(srm_callbacks &callbacks)
{
   for(int i=0;i<noOfChannels;i++)
      {
         srm_set_callbacks(session[i], &callbacks);  
      } 
}


void SRMSever::setProbability(int channelNo,float probabability)
{
   srm_set_drop_probability(session[channelNo], 0.2); 
}

// change later;
int SRMSever::encodeCid(int channelNo, int cid)
{
   return cid;
}

void SRMSever::cleanup()
{
}

SRMSever::~SRMSever()
{
   cleanup();
}


