/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999 Ming Lu, computer science, cornell university
 * All rights reserved.
 *
 * This package can be used for non-profit, non-commercial
 * purpose. For any other purpose, please contact the author at 
 * ml124@cornell.edu
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*******************************
 *
 *  SRMSever.h
 *
 *  $Id: SRMSever.h,v 1.5 1999/05/06 20:58:00 minglu Exp $
 *  $log$
 *
 *******************************/



#ifndef SRMSever_H
#define SRMSever_H
#include <unistd.h>
#include <string.h>
#include <sys/stat.h>
#include <glob.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>


class SRMSever
{
protected:
  
   unsigned int *addr;
   unsigned int *port;
   unsigned int *ttl;
   float *bandwidth;
   int noOfChannels;   
   

public:
   
   SRMSever();
   SRMSever(unsigned int *_addr,
             unsigned int *_port,
            unsigned int *_ttl,
            int _noOfChannels=1);
   
   void init(unsigned int *_addr,
                    unsigned int *_port,
                    unsigned int *_ttl,
                    int _noOfChannels);
   

   void cleanup();
   
   virtual ~SRMSever();
   
};
#endif
