/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999 Ming Lu, computer science, cornell university
 * All rights reserved.
 *
 * This package can be used for non-profit, non-commercial
 * purpose. For any other purpose, please contact the author at 
 * ml124@cornell.edu
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
import java.net.*;
import java.io.*;

public class Server
{
	final static int thePort =1234;
	ServerSocket theServerSocket;
  static String SRMSeverHost=null;
  static int SRMSeverPort;

    
	public static void main(String args[])
	{
       System.out.println(" args.length:" +args.length);
       if(args.length<2)
          {
             System.out.println("usage : java Server SRMSeverHost SRMSeverPort\n");
             System.exit(1);
             
          }
       
        SRMSeverHost=args[0];
        SRMSeverPort=Integer.parseInt(args[1]);
       
		Server theApp = new Server();
		theApp.run();
}
public Server()
{
	try
    {
	 theServerSocket = new ServerSocket(thePort);
    }
	catch(IOException io)
	{
		System.err.println("Socket error: terminating");
		System.exit(1);
	}
}

public void run()
{
	try
	{
		System.out.println("Welcome to the NetFlick Registration Server");
		while(true)
		{
			Socket theSocket = theServerSocket.accept();
			System.out.println("Select a Movie and Register to join a Multicast Group to watch it");
			Connection connection = new Connection (theSocket,SRMSeverHost,SRMSeverPort);
		}
	}
	catch (IOException io)
	{
		System.err.println("Socket error: terminating");
		System.exit(1);
	}
}
}

class Connection extends Thread
{  Socket SRMSeverSocket;
  
   
	Socket theSocket;
	BufferedReader in;
	PrintWriter out;
	BufferedReader reader = null;
	int SRMSeverPort;
   String SRMSeverHost=null;

   
public Connection(Socket socket,String _SRMSeverHost,int _SRMSeverPort)
	{
       SRMSeverHost=_SRMSeverHost;
       SRMSeverPort=_SRMSeverPort;

       
	 try
	 {
		 theSocket = socket;
		 in = new BufferedReader(new InputStreamReader(theSocket.getInputStream()));
		 out = new PrintWriter(new OutputStreamWriter(theSocket.getOutputStream()), true);
		 start();
	 }
		catch(IOException io)
		{
		System.err.println("Socket error: terminating");
		System.exit(1);
	    }
	}
	
	
	public void run()
	{
		int client =0;
		int key=1;
		String Multicast1="224.4.4.4";
		String Multicast2="224.4.4.4";
		String Multicast3="224.4.4.4";
		String port1="4440";
		String port2="4540";
		String port3="4640";
		String mline;
		
		try
		{
			client = theSocket.getPort();
			System.out.println("Client connecting on port" + client +".");
			//out.println(" Type the Full Name of the movie in the box above");
			
			while (true)
			{
				String line = in.readLine();
				//int nread=0;
				//change this later to read from a file, check on movie status and return multicast address
				//port number, time
				if(line == null)
					break;
                
				if (line.compareTo("Real Time")==0)
				{
					String Mcast= new String(port1);
					Mcast=Mcast.concat(" ");
					Mcast=Mcast.concat(Multicast1);
					Mcast=Mcast.concat(" ");
					Mcast=Mcast.concat(line);
					System.out.println("Client on port " + client +" wants " +line+ ".");
					out.println("Thanks for your request.Join Multicast group "+Multicast1+" on port"+ port1+ "to view the movie");
					out.println(Mcast);


  ////   Inform the SRMSever a request has come in
                    System.out.println("SRMSeverHost:"+SRMSeverHost+"\n");
                SRMSeverSocket=new Socket(SRMSeverHost,SRMSeverPort);
                System.out.println("----SRMSeverHost:"+SRMSeverHost+"\n");
                PrintWriter outToSRMSever=new PrintWriter(new OutputStreamWriter(SRMSeverSocket.getOutputStream()),true);
                outToSRMSever.println(Mcast);
                System.out.println("Sent to the SRMSever successfully!");
                SRMSeverSocket.close();
                outToSRMSever=null;
                
                    /////////////////////////////////////////



                    
				}
				else if (line.compareTo("God bless you")==0)
				{
					String Mcast= new String(port2);
					Mcast=Mcast.concat(" ");
					Mcast=Mcast.concat(Multicast2);
					Mcast=Mcast.concat(" ");
					Mcast=Mcast.concat(line);
					System.out.println("Client on port " + client +" wants " +line+ ".");
					out.println("Thanks for your request. Join Multicast group "+Multicast2+ " on port "+port2+"to view the movie");
					out.println(Mcast);


////   Inform the SRMSever a request has come in
                
                SRMSeverSocket=new Socket(SRMSeverHost,SRMSeverPort);
                
                PrintWriter outToSRMSever=new PrintWriter(new OutputStreamWriter(SRMSeverSocket.getOutputStream()),true);
                outToSRMSever.println(Mcast);
                System.out.println("Sent to the SRMSever successfully!");
                SRMSeverSocket.close();
                outToSRMSever=null;
                
                
                    /////////////////////////////////////////







                    
				}
				else if(line.compareTo("My wish")==0)
				{
					String Mcast= new String(port3);
					Mcast=Mcast.concat(" ");
					Mcast=Mcast.concat(Multicast3);
					Mcast=Mcast.concat(" ");
					Mcast=Mcast.concat(line);


                    
                    
					System.out.println("Client on port " + client +" wants " +line+ ".");
					out.println("Thanks for your request. Join Multicast group "+Multicast3+ " on port "+port3+" to view the movie");
					out.println(Mcast);

////   Inform the SRMSever a request has come in
                    System.out.println("SRMSeverHost:"+SRMSeverHost+"\n");
                    
                SRMSeverSocket=new Socket(SRMSeverHost,SRMSeverPort);
                System.out.println("-----SRMSeverHost:"+SRMSeverHost+"\n");
                PrintWriter outToSRMSever=new PrintWriter(new OutputStreamWriter(SRMSeverSocket.getOutputStream()),true);
                outToSRMSever.println(Mcast);
                System.out.println("Sent to the SRMSever successfully!");
                SRMSeverSocket.close();
                outToSRMSever=null;
                
                
                    /////////////////////////////////////////
                    
				}
				
				
			}
			in.close();
			out.close();
			theSocket.close();
		}
		catch (IOException io)
		{
			System.err.println("Client on port "+ client + " has left");
		}
	}
}
			


