/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999 Ming Lu, computer science, cornell university
 * All rights reserved.
 *
 * This package can be used for non-profit, non-commercial
 * purpose. For any other purpose, please contact the author at 
 * ml124@cornell.edu
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
#include <stdio.h>
//#include "SRMSever.h"
//#include "TextSRMSever.h"
#include "VideoSRMSever.h"
#include "PyramidEncoder.h"
#include "Video.h"
#include "TestVideo.h"
#include "MPEGVideo.h"
class VideoSRMSever;

#include "VideoSRMChannelSever.h"
#include "VideoSRMSever.h"
#include <unistd.h>
#include "PPMClient.h"
#include "SocketServer.h"
extern "C"
{
#include "io-util.h"
};


#define MAXChannels 5
#define TTL 16

char * __tolower(char * s)
{
   for(int i=0;i<strlen(s);i++)
      s[i]=tolower(s[i]);
   return s;
}
char *deleteExtraSpaces(char *s)
{
   char *ss;
   ss=new char(strlen(s)+1);
   int k=0;

   for(int i=0;i<strlen(s);i++)
      {
         
      }
   
   
   
}

int findMovieFilename(char *title,char *filename)
{
   FILE *fp;
   fp=fopen("/home/minglu/meng/SRM/example/movieList.txt","r");
   char line[120];

   char tmpTitle[24];
   char cpTitle[24];
   strcpy(cpTitle,title);
   
   for(;;)
      {
         
         if(fgets(line,120,fp)==NULL)
            {
               strcpy(filename,"");
               return 0;
            }
         for(int i=0;i<120;i++)
            {
               if(line[i]=='\n')
                  {
                     line[i]='\0';
                     break;
                  }
               
            }
         
         sscanf(line,"%s",(char*)filename);
         strcpy(tmpTitle,strpbrk(line," ")+1);
         strcpy(tmpTitle,__tolower(tmpTitle));
         if(strcmp(tmpTitle,__tolower(cpTitle))==0)
            return 1;
         
      }
}
int main(int argc, char **argv)
{

   int myPort;
   int noOfChannels;
   int interval;
   
   if(argv<4)
      {
         printf(" %s port numberOfChannels intervals\n",argv[0]);
         exit(1);
      }
   interval=atoi(argv[3]);
   
   noOfChannels=atoi(argv[2]);
   myPort=atoi(argv[1]);
   
   SocketServer s(myPort);

         if(s.accept())
      {
//         if(fork())
            {
               char request[121];
               int multicastPort;
               char multicastIP[20];
               unsigned int multicastAddr;
               char title[100];
               Video *videoServer;
//               strcpy(request,"4444 224.4.4.4 God blessing you");

               
               s.readString((char *)request,120);
               for(int i=0;i<strlen(request);i++)
                  {
                     if(request[i]=='\n')
                        {
                        request[i]='\0';
                        break;
                        }
                  }
               
               sscanf(request,"%d%s",&multicastPort,(char *)multicastIP);
               multicastAddr = (unsigned) LookupHostAddr("224.4.4.4");
               strcpy(title,strpbrk(request," "));
               strcpy(title,strpbrk(title+1," ")+1);


               if( strcmp(tolower(title),"Real Time")==0)
                  {
                  //do it as real time video
              

                     TestVideo *rtVideo;
                     
                     rtVideo=new TestVideo;
                     PPMClient *ppmClient;
                     ppmClient=new PPMClient("ringding.cs.cornell.edu",4000);
                     rtVideo->setPPMClient(ppmClient);
                     videoServer=rtVideo;
                  }
               else
                  {
                         //find the movie file
                     char filename[24];
                     findMovieFilename(title,filename);
                     if(strlen(filename)!=0)
                        videoServer=new MPEGVideo(filename);
                     else 
                        {
                           fprintf(stderr,"No such a movie\n");
                        }
                  }

               unsigned int * _addr;
               unsigned int * _port;
               unsigned int * _ttl;
               _addr=new int[MAXChannels];
               _port=new int[MAXChannels];
               _ttl=new  int[MAXChannels];    
               
               for(int i=0;i<MAXChannels;i++)
                  {
                     _ttl[i]=TTL;
                     _port[i]=multicastPort+i;
                     _addr[i]=multicastAddr; 
                  }
               VideoSRMSever server(_addr,_port,_ttl,noOfChannels);
                   //Video Server
               server.setVideo(videoServer);
                   //set Encoder
               PyramidEncoder pyramidEncoder(noOfChannels);
               server.setEncoder(pyramidEncoder); 
            
// now do the work
               int frameNo=0;
               hrtime_t start, end;
               start= gethrtime();
               
               while(1)
                  {
                     Tcl_DoOneEvent(0);
                     end= gethrtime();
                     if(((end-start)>>20)>interval)
                        {
                           frameNo++;
                           server.sendData(frameNo);
                           start=end;
                        }
                  }
               
            }
         
      }
   
}

















