/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999 Ming Lu, computer science, cornell university
 * All rights reserved.
 *
 * This package can be used for non-profit, non-commercial
 * purpose. For any other purpose, please contact the author at 
 * ml124@cornell.edu
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*
 *    static char *const RCSId ="  $Id ";
 */

#include "SocketServer.h"

SocketServer::SocketServer()
{

   

}

SocketServer::SocketServer(int portNumberOfServer)
{
   serverPortNumber=portNumberOfServer;


    my_addr.sin_family = AF_INET;         /* host byte order */
    my_addr.sin_port = htons(serverPortNumber);     /* short, network byte order */
    my_addr.sin_addr.s_addr = INADDR_ANY; /* automatically fill with my IP */
    bzero(&(my_addr.sin_zero), 8);        /* zero the rest of the struct */

    if (bind(socketFD, (struct sockaddr *)&my_addr, sizeof(struct sockaddr)) == -1) {
        perror("bind");
        exit(1);
    }

    if (listen(socketFD, BACKLOG) == -1) {
        perror("listen");
        exit(1);
    }
   
}
void SocketServer::clientServingFunction()
{
   cout<<"Nothing is done !"<<endl;
   
}

void SocketServer::servingClient()
{
   char tmpStringRead[8000];
   
   while(1) { 
      sin_size = sizeof(struct sockaddr_in);
      if ((clientSocketFD = ::accept(socketFD, (struct sockaddr *)&their_addr, &sin_size)) == -1) {
         perror("accept");
            continue;
      }
//      printf("server: got connection from %s\n",inet_ntoa(their_addr.sin_addr));
      if (fork()) {
         clientServingFunction();
      }
      

         
      close(clientSocketFD);  
      
      while(waitpid(-1,NULL,WNOHANG) > 0); 
   } 
}

SocketServer::~SocketServer()
{
   close(socketFD);
}

int SocketServer::sendString(char *stringSend, int stringSendLength)
{
   return Socket::sendString(clientSocketFD,stringSend,stringSendLength);
}


int SocketServer::accept()
{
    sin_size = sizeof(struct sockaddr_in);
      if ((clientSocketFD = ::accept(socketFD, (struct sockaddr *)&their_addr, &sin_size)) == -1) {
         perror("accept");

      }
//      printf("server: got connection from %s\n",inet_ntoa(their_addr.sin_addr));
}

int SocketServer::readString(char * stringRead, int len)
{
   Socket::readString(clientSocketFD,stringRead,len);
   
}

int SocketServer::readString(char * stringRead)
{
   return Socket::readString(clientSocketFD,stringRead);
   
}
