/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999 Ming Lu, computer science, cornell university
 * All rights reserved.
 *
 * This package can be used for non-profit, non-commercial
 * purpose. For any other purpose, please contact the author at 
 * ml124@cornell.edu
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*******************************
 *
 *  TestVideo.cc
 *
 *  $Id: TestVideo.cc,v 1.5 1999/05/11 00:53:40 minglu Exp $
 *  $log$
 *
 *******************************/

#include <iostream.h>
#include <assert.h>
#include "TestVideo.h"
extern "C"
{
#include "io-util.h"   
};


TestVideo::TestVideo()
{
   
}

TestVideo::TestVideo(unsigned char *name)
{
   rows=-1000;
   
}


TestVideo::TestVideo(const TestVideo & that)
{
   copy(that);
}

TestVideo & TestVideo::operator=(const TestVideo &that)
{
   
   if( this==&that)   // note: this is ONLY good for single inheritance
      return *this;  
   
       // IMPORTANT
       // if this is a child class of some base class Base, then do this first :
       //  Base::operator=(that);

       
   cleanup(); // in the case of inheritance, cleanup and copy can be VIRTUAL FUNCTIONS !!
   copy(that);
      
   return *this;
}

int TestVideo::operator==(const TestVideo &right)
{
   
}

int TestVideo::operator!=(const TestVideo &right)
{
   return !(operator==(right));
}

TestVideo::~TestVideo()
{
   cleanup();
}

// delete the memory used by this class
void TestVideo::cleanup()
{
   
}

void TestVideo::copy(const TestVideo & that)
{
   
}


void TestVideo::debug(void * p)
{
#ifdef DEBUG 
   assert(p);
   cerr<<__LINE__;
#endif
}

void TestVideo::getFrame(int seqno, unsigned char * image,int &rows, int &cols, int &colors)
{
    colors=3;
    PPMClient ppm("ringding",4000);
    ppm.readImage(cols,rows,colors,image);
    ppm.close();
    printf(" in TestVideo : rows=%d cols =%d \n",rows,cols);
}
void TestVideo::setPPMClient(PPMClient *_ppmClient)
{
   ppmClient=_ppmClient;
   
}
