/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999 Ming Lu, computer science, cornell university
 * All rights reserved.
 *
 * This package can be used for non-profit, non-commercial
 * purpose. For any other purpose, please contact the author at 
 * ml124@cornell.edu
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*******************************
 *
 *  TestVideo.h
 *
 *  $Id: TestVideo.h,v 1.2 1999/05/08 22:44:24 minglu Exp $
 *  $log$
 *
 *******************************/

#ifndef TestVideo_H
#define TestVideo_H

#include "Video.h"
#include "PPMClient.h"
class TestVideo:public Video
{
private:
   void copy(const TestVideo & src);
   void cleanup();
   PPMClient *ppmClient;
   
public:
   
   TestVideo();
   TestVideo(unsigned char *name);
   TestVideo(const TestVideo & that);
   virtual ~TestVideo();
   void setPPMClient(PPMClient *_ppmClient);
   
   TestVideo & operator=(const TestVideo &that);
   int operator==(const TestVideo &right);
   int operator!=(const TestVideo &right);

   void getFrame(int seqno,unsigned char *frame, int &rows, int &cols, int &colors);
   
   void debug(void * p);
};

#endif /* TestVideo_H */

