/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999 Ming Lu, computer science, cornell university
 * All rights reserved.
 *
 * This package can be used for non-profit, non-commercial
 * purpose. For any other purpose, please contact the author at 
 * ml124@cornell.edu
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*******************************
 *
 *  TestVideoClient.cc
 *
 *  $Id: TestVideoClient.cc,v 1.6 1999/05/11 00:53:40 minglu Exp $
 *  $log$
 *
 *******************************/

#include <iostream.h>
#include <assert.h>
#include "TestVideoClient.h"
//#include "io-pgm.c"
extern "C"
{
   
#include "io-util.h"
}

TestVideoClient::TestVideoClient()
{
   
}



TestVideoClient::TestVideoClient(const TestVideoClient & that)
{
   copy(that);
}

TestVideoClient & TestVideoClient::operator=(const TestVideoClient &that)
{
   
   if( this==&that)   // note: this is ONLY good for single inheritance
      return *this;  
   cleanup(); // in the case of inheritance, cleanup and copy can be VIRTUAL FUNCTIONS !!
   copy(that);
      
   return *this;
}

int TestVideoClient::operator==(const TestVideoClient &right)
{
   
}

int TestVideoClient::operator!=(const TestVideoClient &right)
{
   return !(operator==(right));
}

TestVideoClient::~TestVideoClient()
{
   cleanup();
}

// delete the memory used by this class
void TestVideoClient::cleanup()
{
   
}

void TestVideoClient::copy(const TestVideoClient & that)
{
   
}


void TestVideoClient::debug(void * p)
{
#ifdef DEBUG 
   assert(p);
   cerr<<__LINE__;
#endif
}

void TestVideoClient::play(unsigned char *image, int rows, int cols, int colors)
{
   char tmp[100];
   sprintf(tmp,"%4d %4d %2d \n",cols,rows,3);
    
   socketServer->sendString(tmp,15);
   socketServer->sendString((char *)image,rows*cols*colors);
}

   
