/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999 Ming Lu, computer science, cornell university
 * All rights reserved.
 *
 * This package can be used for non-profit, non-commercial
 * purpose. For any other purpose, please contact the author at 
 * ml124@cornell.edu
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*******************************
 *
 *  TestVideoClient.h
 *
 *  $Id: TestVideoClient.h,v 1.1 1999/05/02 00:12:19 minglu Exp $
 *  $log$
 *
 *******************************/

#ifndef TestVideoClient_H
#define TestVideoClient_H

#include "VideoClient.h"

class TestVideoClient: public VideoClient
{
private:
   void copy(const TestVideoClient & src);
   void cleanup();

public:
   
   TestVideoClient();

   TestVideoClient(const TestVideoClient & that);
   virtual ~TestVideoClient();

   TestVideoClient & operator=(const TestVideoClient &that);
   int operator==(const TestVideoClient &right);
   int operator!=(const TestVideoClient &right);


   
   void debug(void * p);
   void play(unsigned char *image, int rows, int cols, int colors);
   
};

#endif /* TestVideoClient_H */

