/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999 Ming Lu, computer science, cornell university
 * All rights reserved.
 *
 * This package can be used for non-profit, non-commercial
 * purpose. For any other purpose, please contact the author at 
 * ml124@cornell.edu
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*******************************
 *
 *  Video.h
 *
 *  $Id: Video.h,v 1.2 1999/05/08 22:44:24 minglu Exp $
 *  $log$
 *
 *******************************/

#ifndef Video_H
#define Video_H

#include <iostream.h>
class Video
{
private:
   void copy(const Video & src);
   void cleanup();
protected:
   
   unsigned char *frameData;
   int rows;
   int cols;
   int color;
   int sizeOfOneFrame;
   
public:
   
   Video();

   Video(const Video & that);
   virtual ~Video();

   Video & operator=(const Video &that);
   int operator==(const Video &right);
   int operator!=(const Video &right);


   
   void debug(void * p);
       
   virtual void getFrame(int seqno,unsigned char *frame,int &rows, int &cols, int &colors)=0;
   
};

#endif /* Video_H */

