/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999 Ming Lu, computer science, cornell university
 * All rights reserved.
 *
 * This package can be used for non-profit, non-commercial
 * purpose. For any other purpose, please contact the author at 
 * ml124@cornell.edu
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*******************************
 *
 *  VideoClient.cc
 *
 *  $Id: VideoClient.cc,v 1.2 1999/05/08 22:43:35 minglu Exp $
 *  $log$
 *
 *******************************/

#include <iostream.h>
#include <assert.h>
#include "VideoClient.h"

VideoClient::VideoClient()
{
   
}



VideoClient::VideoClient(const VideoClient & that)
{
   copy(that);
}

VideoClient & VideoClient::operator=(const VideoClient &that)
{
   
   if( this==&that)   // note: this is ONLY good for single inheritance
      return *this;  
   
   cleanup(); // in the case of inheritance, cleanup and copy can be VIRTUAL FUNCTIONS !!
   copy(that);
      
   return *this;
}

int VideoClient::operator==(const VideoClient &right)
{
   
}

int VideoClient::operator!=(const VideoClient &right)
{
   return !(operator==(right));
}

VideoClient::~VideoClient()
{
   cleanup();
}

// delete the memory used by this class
void VideoClient::cleanup()
{
   
}

void VideoClient::copy(const VideoClient & that)
{
   
}


void VideoClient::debug(void * p)
{
#ifdef DEBUG 
   assert(p);
   cerr<<__LINE__;
#endif
}

void VideoClient::setServerSocket(SocketServer *s)
{
   socketServer=s;
}
