// Java GIF or JPEG Video Player W.B.Langdon@cs.bham.ac.uk February 1998
// $Revision: 1.17 $
// General Animation Applet by Chris Sidney 1996
// Modified from examples in "The JAVA Sourcebook" by Ed Anuff
// and "Hooked on Java" by Sun Microsystems
//
//  * Adding the Java code to your page *
//
//  Copy the "AnimationApplet.class" file to the same directory
//  as your html files or use this file to create it using
//  the Java Developement Kit from Sun Microsystems. 
//  Copy the images to the same directory 
//  or a sub-directory. Add the code below to your html file.
//
//  <APPLET CODE=VideoPlayer.class WIDTH=104 HEIGHT=96>
//
//  <PARAM NAME=framedelay VALUE=60000>		Time in milliseconds
//  <PARAM NAME=imagename VALUE="dir/advert">	Imagename & directory
//  <PARAM NAME=suffix VALUE=".gif">	        GIF or JPG
//  <PARAM NAME=firstframe VALUE=1>		First image number
//  <PARAM NAME=lastframe VALUE=10>		Last image number
//  <PARAM NAME=showrandom VALUE=TRUE>		Displays random images
//  <PARAM NAME=bgcolor VALUE="FF00FF">		Colour - default light gray
//  <PARAM NAME=link VALUE="http://www.etc.">	Optional Link URL/message
//
//  </APPLET>
//
//  Your Image file names: Use ImageName+number+gif.
//  For example: advert1.gif, advert2.gif etc.
//
//  Add optional sub-directory relative to source html file
//  for example: VALUE="images/advert".
//
//  If you don't use the ImageName the default files can be
//  1.gif, 2.gif etc. Default delay is 60 seconds.
//  Default FirstFrame is 1 - the only Parameter you REALLY need
//  is the LastFrame value.
//
// Use the link parameter to add your own mouseOver message. Or VALUE=""
// to stop the copyright display. If the URL is not valid it will be
// displayed as if it was a mouseOver message
//

import java.applet.*;
import java.awt.*;
import java.util.Vector;
import java.util.BitSet;
import java.net.*;

class VideoPlayerCanvas extends Canvas {
	VideoPlayer p;
VideoPlayerCanvas(VideoPlayer parent){
	p=parent;
}
public void paint(Graphics g){
	if(p.shadowImage!=null) 
	  g.drawImage(p.shadowImage,0,0,this);
	else {
	  g.setColor(Color.red);
	  g.fillRect(0,0,size().width, size().height);
        }
//	p.status("Frame "+p.currentImage+" "+size().width+"x"+size().height);
}
public void update(Graphics g){

	paint(g);

}
}//end class VideoPlayerCanvas

public class VideoPlayer extends Frame implements Runnable
{
   static String host;
   static int port;
   
	MediaTracker theTracker;
	Vector frames=new Vector();
	int firstFrame;
	int lastFrame;
	int currentImage;
	Thread timer;
	int frameDelay;
	int speed;
	Color bgcolor;	
	boolean showRandom;
	URL linkURL=null;
        String target;
	String copyright="Bill's Video Player $Revision: 1.17 $";
	String statusText=copyright;
	VideoPlayerCanvas swatch = new VideoPlayerCanvas(this);
	Image thisImage;
        Image shadowImage; //used by VideoPlayerCanvas

// create control buttons

	Button begining  = new Button("Begining");
	Button stepback  = new Button("<Step");
	Button rewind    = new Button("<<");
	Button backwards = new Button("<");
	Button pause     = new Button("Pause");
	Button forward   = new Button(">");
	Button fast      = new Button(">>");
	Button stepforw  = new Button("Step>");
	Button end       = new Button("End");

/*   
public void status(String s){
        System.out.println(s);
	showStatus(s);
}*/
public void init(){

   firstFrame=1;
   lastFrame=100;
   currentImage=firstFrame;
   
//        status("init $Revision: 1.17 $");
//	URL baseURL=getCodeBase();
//	String parameterValue;
	theTracker=new MediaTracker(this);

/*	
// read the frame delay in milliseconds
	
	parameterValue=getParameter("framedelay");
	frameDelay=numberFromString(parameterValue,60000);
	speed = 0;

// read the image name - can be null

	String imageName=getParameter("imagename");

// read in the image suffix - default gif
	
	String suffix=".gif";
	parameterValue=getParameter("suffix");
	if(parameterValue!=null)
	suffix=parameterValue;

// read in start frame number

	parameterValue=getParameter("firstframe");
	firstFrame=numberFromString(parameterValue,1);
	currentImage=firstFrame;

// read in last frame number

	parameterValue=getParameter("lastframe");
	lastFrame=numberFromString(parameterValue,firstFrame);

// read in the colour value

	parameterValue = getParameter("bgcolor");
	bgcolor = colorFromString(parameterValue,Color.lightGray);
	setBackground(bgcolor);

// Read in the link URL

	parameterValue = getParameter("link");
	
	if (parameterValue != null) {
	try{
	linkURL = new URL(parameterValue);
	} catch (MalformedURLException e) {
	linkURL = null;
	status("MalformedURLException "+e+" "+parameterValue);
	statusText=parameterValue;
	}
	}
// Read target. If doesn't exist use _TOP.

            parameterValue=getParameter("target");
            if(parameterValue!=null){
            target=parameterValue;
            }
            else{
            target="_TOP";
            }
            */
// Read the images into the frames Vector

	for(int i=firstFrame; i<=lastFrame;i++){
	
// check if gif or jpg file is valid through Tracker
	
	thisImage=Toolkit.getDefaultToolkit().getImage("rec.gif");
//	status("Loading Image "+baseURL+imageName+i+suffix);
	theTracker.addImage(thisImage,0);
	frames.addElement(thisImage);
	}

// add control buttons

	Panel buttons = new Panel();
	buttons.setLayout(new FlowLayout(FlowLayout.CENTER,10,10));
	buttons.add(begining);
	buttons.add(stepback);
	buttons.add(rewind);
	buttons.add(backwards);
	buttons.add(pause);
	buttons.add(forward);
	buttons.add(fast);
	buttons.add(stepforw);
	buttons.add(end);

	GridBagLayout gridbag = new GridBagLayout();
	GridBagConstraints c = new GridBagConstraints();
	setLayout(gridbag);
	c.weightx = 1.0;
	c.weighty = 1.0;
	c.fill = GridBagConstraints.BOTH;
	gridbag.setConstraints(swatch, c);
	add(swatch);
	c.weighty = 0;
	c.fill = GridBagConstraints.NONE;
	c.gridy = 1;
	gridbag.setConstraints(buttons, c);
	add(buttons);
 
// Set up shadow image areas

       	shadowImage=swatch.createImage(size().width,size().height);//max size

// Wait until all frames loaded

	try{
	theTracker.waitForAll();
	} catch (InterruptedException e){
//	status("InterruptedException "+e);
	return;
	}

}

public void start(){

	if(timer !=null) {
	  System.out.println("start resume");
	  timer.resume();
	}
	else {
	  System.out.println("start new");
	  timer=new Thread(this);
	  timer.start();
	}
}

public void stop(){
        System.out.println("stop");

	if(timer!=null){
	  timer.stop();
	  timer=null;	
	}
}

void now(){
        stop();
	start();
}

public void run(){
	while (timer!=null){

// show images

	paintFrame();

	try{
	if(speed>0) {
	  if(currentImage >= lastFrame  ) break;
	  else Thread.sleep(speed); }
	else if(speed<0) {
	  if(currentImage <= firstFrame ) break;
	  else Thread.sleep(-speed); }
	else break;
	} catch (InterruptedException e) {
	break;
	}

	if(speed>0) currentImage++;
	if(speed<0) currentImage--;
}
}//end run

public int numberFromString(String numberString, int defaultNumber) {

	Integer i;
	try {
	i = Integer.valueOf(numberString);
	return i.intValue();
	} catch (NumberFormatException e){
	return defaultNumber;
	}
	}
	

public Color colorFromString(String colorString, Color defaultColor) {

	Integer i;
	try {
	i = Integer.valueOf(colorString, 16);
 	return new Color(i.intValue());
	} catch (NumberFormatException e){
	return defaultColor;
	}
}



  public boolean
            imageUpdate(Image  img, int  infoflags,
            int  x, int  y, int  width, int  height)
  {
  if(img!=thisImage) 
    return super.imageUpdate(img, infoflags, x, y, width, height);

  if ( (infoflags & ALLBITS) != 0)
    {
//  System.out.println( "fully downloaded" );
    shadowImage = thisImage;
    swatch.repaint();
//  if(timer!=null) timer.resume(); 
    return false;
    }
  else
    {
//  if(timer!=null) timer.suspend();netscape 3.02 netscape.applet.AppletSecurity.checkAccess throws security.thread
    return true;
    }
  }


public void paintFrame(){

   System.out.println("1111111111");
/*   
	if(theTracker.isErrorAny()){
	shadowImage = null; //dont worry about repaint
//	status("Java Applet cannot locate Image");
	return;
	}*/
    System.out.println("22222222");
    
	if(currentImage>=firstFrame && currentImage<=lastFrame){
	
	thisImage=(Image)frames.elementAt(currentImage-1);
	System.out.println("333333333333");
    
	if(thisImage==null)
	  shadowImage = null; //dont worry about repaints
	else {
//	  status("Frame "+currentImage);

	  Graphics g = swatch.getGraphics();
	  g.drawImage(thisImage,0,0,swatch.size().width,
	  		                 swatch.size().height,bgcolor, this);

	  /***************************************************
          * imageUpdate may be invoked, particularly if frame has not been
          * displayed before. However it may be called after this code is run
          * resulting in at most two calls to swatch.repaint(). However putting
          * this code in applet:paint() used to result in it being called many
          * times (as each new part of the frame became available).
          ***************************************************/

	  System.out.println("update shadowImage");
	  shadowImage = thisImage;
	  swatch.repaint();
	}
	}
	return;
}

public boolean action(Event evt, Object arg) {
if(evt.target instanceof Button) {
if (arg.equals("Begining")) {speed = 0;   currentImage = firstFrame; now();}
else if(arg.equals("<Step")){speed = 0;              --currentImage; now();}
else if(arg.equals("<<"))   {speed = -frameDelay/10; --currentImage; now();}
else if(arg.equals("<"))    {speed = -frameDelay;    --currentImage; now();}
else if(arg.equals("Pause")){speed = 0; stop();}
else if(arg.equals(">"))    {speed = frameDelay;     ++currentImage; now();}
else if(arg.equals(">>"))   {speed = frameDelay/10;  ++currentImage; now();}
else if(arg.equals("Step>")){speed = 0;              ++currentImage; now();}
else if(arg.equals("End"))  {speed = 0;	   currentImage = lastFrame; now();}
else return false;

if(currentImage > lastFrame  ) currentImage = lastFrame;
if(currentImage < firstFrame ) currentImage = firstFrame;

return true;
}
else	return false;
}//end action
/*
public boolean mouseEnter(Event evt, int x, int y){

	if (linkURL != null) {
	status("Shortcut to "+linkURL);
	}
	else{
	status(statusText);
	}
	return true;
}


public boolean mouseDown(Event evt, int x, int y){

	if (linkURL != null){
	status("Linking to: "+linkURL);
	getAppletContext().showDocument(linkURL,target);
	}
	return true;
}


public String getAppletInfo(){

	return copyright;
	}


public String[][] getParameterInfo(){

// Default values shown in brackets

	String[][]info={

	{"framedelay","int", "Delay between frames in milliseconds (60000)"},
	{"firstframe","int", "First frame number (1)"},
	{"lastframe","int", "Last frame number (1)"},
	{"showrandom","boolean","If true show images in random order (false)"},
	{"imagename","String","Directory and image name ()"},
	{"suffix","String","Image file type .GIF or .JPG (.GIF)"},
	{"bgcolor","Color","Hexadecimal color value (C0C0C0)"},
	{"link","URL","Link to site by clicking Applet ()"},
	
	};
	return info;

	}
    */
  public static void main(String args[]) {
        VideoPlayer videoPlayer = null;
        int fps = 10;

        // Get frames per second from the command line argument

        if (args.length > 0) {
            try {
                fps = Integer.parseInt(args[0]);
                port=Integer.parseInt(args[1]);
            } catch (Exception e) {}
        }
        host="ringding";
        
//        VideoPlayer = new VideoPlayer(fps, "Animator");
        videoPlayer=new VideoPlayer();
        
        videoPlayer.setSize(640, 480);
        videoPlayer.setVisible(true);
        videoPlayer.start();
    }


   
}

//
// Please feel free to use this Applet or any part of it in your pages.
// Chris Sidney - cjsidney@global.i-way.co.uk
//
