/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999 Ming Lu, computer science, cornell university
 * All rights reserved.
 *
 * This package can be used for non-profit, non-commercial
 * purpose. For any other purpose, please contact the author at 
 * ml124@cornell.edu
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*******************************
 *
 *  VideoSRMChannelClient.cc
 *
 *  $Id: VideoSRMChannelClient.cc,v 2.1 1999/05/05 22:59:21 minglu Exp $
 *  $log$
 *
 *******************************/


#include <assert.h>
#include "VideoSRMChannelClient.h"
//#include "_decode.cc"
extern "C" 
{
#include "io-util.h"
};
//#include "PyramidPack.cc"

 VideoSRMClient* VideoSRMChannelClient::videoClient;
VideoSRMChannelClient::VideoSRMChannelClient()
{

}

VideoSRMChannelClient::VideoSRMChannelClient(
   unsigned int _addr,
   unsigned int _port,
   unsigned int _ttl,
   int _channelID,
   VideoSRMClient *_videoClient
   ):SRMChannelClient(_addr,_port,_ttl)
{

   srm_callbacks callbacks= {
       srm_recv,
      srm_should_recover,
      srm_read_adu,
      srm_source_update
   }; 
//   init(_addr,_port,_ttl,_channelID);
   setCallbacks(callbacks);
   videoClient=_videoClient;
   
}
void VideoSRMChannelClient::init(
   unsigned int _addr,
   unsigned int _port,
   unsigned int _ttl,
   int _noOfChannels)
{
}



VideoSRMChannelClient::VideoSRMChannelClient(const VideoSRMChannelClient & that)
{
   copy(that);
}

VideoSRMChannelClient & VideoSRMChannelClient::operator=(const VideoSRMChannelClient &that)
{
   
   if( this==&that)   // note: this is ONLY good for single inheritance
      return *this;  
   
       // IMPORTANT
       // if this is a child class of some base class Base, then do this first :
       //  Base::operator=(that);

       
   cleanup(); // in the case of inheritance, cleanup and copy can be VIRTUAL FUNCTIONS !!
   copy(that);
      
   return *this;
}

int VideoSRMChannelClient::operator==(const VideoSRMChannelClient &right)
{
   
}

int VideoSRMChannelClient::operator!=(const VideoSRMChannelClient &right)
{
   return !(operator==(right));
}

VideoSRMChannelClient::~VideoSRMChannelClient()
{
   cleanup();
}

// delete the memory used by this class
void VideoSRMChannelClient::cleanup()
{
   
}

void VideoSRMChannelClient::copy(const VideoSRMChannelClient & that)
{
   
}



void VideoSRMChannelClient::debug(void * p)
{
#ifdef DEBUG 
   assert(p);
   cerr<<__LINE__;
#endif
}

void VideoSRMChannelClient::srm_recv(srm_source_t _source,
                             unsigned int cid,
                             unsigned int seqno ,
                             const unsigned char *data,
                             int len,
                             const srm_adu_info * info)
{

   char tmp[51];
   int channelID=100; // this will be obtained from the cid.
   int seqNo;
   memcpy(tmp,data,50);
   tmp[50]='\0';
   sscanf(tmp,"%d%d",&channelID,&seqNo);
   
//   decipher(_source,cid,channelID,seqNo);

   videoClient->playVideo(seqNo,channelID,data,len);

     
}


int VideoSRMChannelClient::srm_should_recover(srm_source_t source,
                                  unsigned int cid,
                                  unsigned int ss,
                                  unsigned int es)
{
   return 0;
}


void VideoSRMChannelClient::srm_read_adu(srm_source_t source,
                            unsigned int cid,
                            unsigned int seqno ,
                            unsigned char **data_ptr,
                            unsigned int *len_ptr,
                            srm_free_proc *free_proc_ptr,
                            srm_adu_info * info)
   
{
   
}


void VideoSRMChannelClient::srm_source_update(srm_source_t source ,
                                  const unsigned char *info,
                                  int len)
{
	if (info) {
		printf("\t %s\n", info);
	}
   
}

