/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999 Ming Lu, computer science, cornell university
 * All rights reserved.
 *
 * This package can be used for non-profit, non-commercial
 * purpose. For any other purpose, please contact the author at 
 * ml124@cornell.edu
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*******************************
 *
 *  VideoSRMClient.h
 *
 *  $Id: VideoSRMClient.h,v 2.2 1999/05/08 22:44:24 minglu Exp $
 *  $log$
 *
 *******************************/

#ifndef VideoSRMClient_H
#define VideoSRMClient_H

//#include "SRMClient.h"
#include "LayerDecoder.h"
#define MAX_WIDTH 1000
#define MAX_HEIGHT 1000
class VideoSRMChannelClient;

#include "VideoClient.h"
#include "VideoSRMChannelClient.h"

class VideoSRMClient
{
private:
   void copy(const VideoSRMClient & src);
   void cleanup();
       // this is used to save the higher channels for this later when low channel data is received
   unsigned char **curFrame;
   int width, height;
   
   VideoClient *videoClient;
   LayerDecoder *decoder;
   VideoSRMChannelClient **channels;
   int noOfChannels;
   friend class VideoSRMChannelClient;
   int *lastframe;
   
public:
   
   VideoSRMClient();
   VideoSRMClient(unsigned int *_addr,
                  unsigned int *_port,
                  unsigned int *_ttl,
                  int _noOfChannels);
   void init(unsigned int *_addr,
             unsigned int *_port,
             unsigned int *_ttl,
             int _noOfChannels);
   void setDecoder(LayerDecoder *_decoder);
   void setVideoClient(VideoClient *_videoClient);
   
   VideoSRMClient(const VideoSRMClient & that);
   virtual ~VideoSRMClient();

   VideoSRMClient & operator=(const VideoSRMClient &that);
   int operator==(const VideoSRMClient &right);
   int operator!=(const VideoSRMClient &right);
   
   void debug(void * p);
       
   void playVideo(int seqNo,int channelID,const unsigned char *data, int len);
};

#endif /* VideoSRMClient_H */

