/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999 Ming Lu, computer science, cornell university
 * All rights reserved.
 *
 * This package can be used for non-profit, non-commercial
 * purpose. For any other purpose, please contact the author at 
 * ml124@cornell.edu
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*******************************
 *
 *  VideoSRMSever.h
 *
 *  $Id: VideoSRMSever.h,v 3.0 1999/05/13 16:55:05 minglu Exp minglu $
 *  $log$
 *
 *******************************/

#ifndef VideoSRMSever_H
#define VideoSRMSever_H
#include "SRMSever.h"
#include "ChannelBW.h"
#include "LayerEncoder.h"
#include "Video.h"
#include "VideoSRMChannelSever.h"
#define MAX_WIDTH 640
#define MAX_HEIGHT 480
#define MAX_COLORS 3
class VideoSRMSever
{
private:
   void copy(const VideoSRMSever & src);
   void cleanup();

   LayerEncoder* encoder;
   Video *video;
   unsigned char *videoName;
   friend class VideoSRMChannelSever;
   VideoSRMChannelSever **channels;
   int noOfChannels;
   unsigned char **encodedOut;
   int *outLength;
   unsigned char *frame;
   int encodedOutAllocated;
   
public:
   
   VideoSRMSever();
   VideoSRMSever(unsigned int *_addr,
                 unsigned int *_port,
                 unsigned int *_ttl,
                 int _noOfChannels);
   void init(unsigned int *_addr,
             unsigned int *_port,
             unsigned int *_ttl,
             int _noOfChannels);
   void setEncoder(LayerEncoder &_encoder);
   void setVideo(Video* _video);
   
   VideoSRMSever(const VideoSRMSever & that);
   virtual ~VideoSRMSever();

   VideoSRMSever & operator=(const VideoSRMSever &that);
   int operator==(const VideoSRMSever &right);
   int operator!=(const VideoSRMSever &right);
   void debug(void * p);
   void sendData(int frameNo);
};

#endif /* VideoSRMSever_H */

