/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999 Ming Lu, computer science, cornell university
 * All rights reserved.
 *
 * This package can be used for non-profit, non-commercial
 * purpose. For any other purpose, please contact the author at 
 * ml124@cornell.edu
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*******************************
 *
 *  VideoSever.java
 *
 *  $Id$
 *  $log$
 *
 *******************************/

import java.io.*;
import java.net.*;

public class VideoSever
{

       // for debug only
private static boolean debugControl=false;
private int port;
   boolean listening=true;
   ServerSocket serverSocket=null;
   AbsVideoSever videoSever=null;
   
   
public VideoSever(AbsVideoSever _videoSever,int _port)
         {
            port=_port;
            videoSever=_videoSever;
            
           try {
               serverSocket = new ServerSocket(port);
            } catch (IOException e) {
               System.err.println("Could not listen on port: " +port);
               System.exit(-1);
            } 
            
            }

public void run() throws java.io.IOException
         {
            while(listening)
               {
                  System.out.println("New Thread");
                  new VideoSeverThread(serverSocket.accept(),videoSever).start();
                  

                  
                  
               }
            

            
            }
   


public void debug()
         {
            if (debugControl==true) 
               {
                  System.out.println();
               }
            }
}

