/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999 Ming Lu, computer science, cornell university
 * All rights reserved.
 *
 * This package can be used for non-profit, non-commercial
 * purpose. For any other purpose, please contact the author at 
 * ml124@cornell.edu
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/*
 * 1.1 version.
 */

import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.awt.image.*;
import  java.io.*;
import java.net.*;

/* 
 * Based on Arthur van Hoff's animation examples, this application
 * can serve as a template for all animation applications.
 */
public class Webcam extends Frame 
                                 implements Runnable
{
   int frameNumber = -1;
   int delay;
   Thread animatorThread;
   boolean frozen = false;
   
   URL		url_Webcam;                      
   Image	image_WebcamImage;
   boolean	boolean_Debug;
   

   Dimension offDimension;
   Image offImage;
   Graphics offGraphics;
   int width=0, height=0, colors;
   int oldWidth=0, oldHeight=0,oldColors=0;
   
   Socket client=null;
   static String host=null;
   DataInputStream clientDataInputStream=null;
//   byte[] byteImageData=null;
   static int port;
   int [] unsignedByteImageData=null;
   String movieInfo=null;
   BufferedImage bi=null;
   WritableRaster wr=null;
   
   

   
private Toolkit toolkit;                               
    Webcam(int fps, String windowTitle) {
        super(windowTitle);
        
        delay = (fps > 0) ? (1000 / fps) : 100;
        toolkit = getToolkit();

       try
          {
             
       ServerSocket s=new ServerSocket(10000);
       Socket theSocket=s.accept();
       BufferedReader in = new BufferedReader(new InputStreamReader(theSocket.getInputStream()));
       movieInfo=in.readLine();
       System.out.println("movieInfo: "+movieInfo+" \n");
       
       in.close();
       theSocket.close();
          }
       catch( java.io.IOException e)
          {
             System.out.println("Error to receive MoiveInfo\n");
             System.exit(1);
             
          }
       
      

       
        this.init();
        
    }



public void trace(String message)
	{
		if (boolean_Debug)
		{
			System.out.println(message);
		}
	}

 protected Image getImage(URL url) {

        //    Image img = toolkit.getImage(url);
    Image img=_getImage();
    
        try {
           MediaTracker tracker = new MediaTracker(this);
           tracker.addImage(img, 0);
           tracker.waitForID(0);
        } catch (Exception e) { e.printStackTrace(); }
        return img;
    }

protected Image _getImage()
         {
            readPPMImage();
            
//            SampleModel sm=bi.getSampleModel();
            
            int t=0;
            
            for(int i=0;i<height;i++)
               for(int j=0;j<width;j++)
                  for(int k=0;k<colors;k++)
                  {
                     wr.setSample(j,i,k,unsignedByteImageData[t]);
                     t++;
                  }
            return bi;
            
            }
protected  void readPPMImage()
         {

            byte[] headByte=null;
            headByte=new byte[16];
            
            try
               {
                  clientDataInputStream.readFully(headByte,0,15);
               }
            catch( IOException e)
               {
               }

            
            width= Integer.parseInt((new String(headByte,0,4)).trim());
            height= Integer.parseInt((new String(headByte,5,4)).trim());
            colors= Integer.parseInt((new String(headByte,10,2)).trim());
            

            
                

            if((oldWidth!=width)||(oldHeight!=height)||(oldColors!=colors))
               {
                  oldWidth=width;
                  oldHeight=height;
                  oldColors=colors;
//                  byteImageData=null;
//                  byteImageData=new byte[width*height*colors+1];
                  unsignedByteImageData=new int[width*height*colors+1];
                  if(unsignedByteImageData==null)
                     {
                        System.out.println("Memeory Problem\n");
                        
                     }
                  bi=null;
                  wr=null;
                  bi=new BufferedImage(width,height,BufferedImage.TYPE_INT_RGB);
                  wr=bi.getRaster();
                  
               }

            try
               {
                  for(int i=0;i<width*height*colors;i++)
                     {
                        unsignedByteImageData[i]=clientDataInputStream.readUnsignedByte();
                     }

               }
            catch( java.io.IOException e)
               {
               }
            System.out.println(" width=" +width+"   height="+height+"  colors=" +colors+ "  "+ unsignedByteImageData[0]+ " " +unsignedByteImageData[1]+ " "+unsignedByteImageData[2]+" \n");              
            }
   
public void init()
         {

            String	string_Url;

            int		int_Port;

            string_Url = "http://ringding:3000/";
            try
               {
                  
                  client=new Socket(host, port);
                  clientDataInputStream=new DataInputStream(client.getInputStream());
                      
                  PrintWriter outToSRMClient=new PrintWriter(new OutputStreamWriter(client.getOutputStream()),true);
                  System.out.println("write to SRMClient \n");
                  
                  outToSRMClient.println(movieInfo);                  System.out.println("write to SRMClient ---- DONE\n");
                  
                      outToSRMClient=null;

               }
            catch(java.net.UnknownHostException e)
               {
               }
            catch(IOException f)
               {
               }
            

            try
               {
                  url_Webcam = new URL(string_Url);
                  trace("Target URL="+url_Webcam.toString());
                  image_WebcamImage = getImage(url_Webcam);
                  MediaTracker mediaTracker_track = new MediaTracker(this);
                  mediaTracker_track.addImage(image_WebcamImage, 1);
                  mediaTracker_track.waitForID(1);
               }
            catch(Exception e)
               {
                  trace("Image get exception:"+e.toString());
                  trace("Problem getting initial image: "+e.toString());
                  return;
               }
            
            }
                                    
                                    
    public void startWebcam() {
       System.out.println("startWecam ...\n");
       
        if (frozen) {
            //Do nothing.  The user has requested that we
            //stop changing the image.
        } else {
            //Start animating!
            if (animatorThread == null) {
                animatorThread = new Thread(this);
            }
            animatorThread.start();
        }
    }

    public void stopAnimation() {
        //Stop the animating thread.
        animatorThread = null;
    }

    public void run() {
       System.out.println(" run().... is running ... \n");
       
        //Just to be nice, lower this thread's priority
        //so it can't interfere with other processing going on.
        Thread.currentThread().setPriority(Thread.MIN_PRIORITY);

        //Remember the starting time.
        long startTime = System.currentTimeMillis();

        //Remember which thread we are.
        Thread currentThread = Thread.currentThread();

        //This is the animation loop.
        while (currentThread == animatorThread) {
            //Advance the animation frame.


	try
			{

				trace("Flushing image");
				// Flush the image in the image buffer so we get a new one
				image_WebcamImage.flush();
				// Track the image and wait till its loaded
				MediaTracker mediaTracker_track = new MediaTracker(this);
				mediaTracker_track.addImage(image_WebcamImage, 1);
				mediaTracker_track.waitForID(1);
				// Repaint the image
				repaint();
            }
    
           catch (Exception e)
			{
				trace("Caught:"+e.toString());
			}
            frameNumber++;



            //Delay depending on how far we are behind.
            try {
                startTime += delay;
                Thread.sleep(Math.max(0, 
                             startTime-System.currentTimeMillis()));
            } catch (InterruptedException e) {
                break;
            }
        }
    }

    //Draw the current frame of animation.
    public void paint(Graphics g) {
           /**
       	if (image_WebcamImage != null)
		{
			g.drawImage(image_WebcamImage, 0,0,this);
		}
        **/
       update(g);
       
    }

public void   update(Graphics g)
         {
            Dimension d = size(); 
        //Create the offscreen graphics context, if no good one exists.
        if ( (offGraphics == null)
          || (d.width != offDimension.width)
          || (d.height != offDimension.height) ) {
            offDimension = d;
            offImage = createImage(d.width, d.height);
            offGraphics = offImage.getGraphics();
        }
        
        image_WebcamImage = getImage(url_Webcam);
        //Erase the previous image.
        offGraphics.setColor(getBackground());
        offGraphics.fillRect(0, 0, d.width, d.height);
        offGraphics.setColor(Color.black);

        offGraphics.drawImage(image_WebcamImage,0, 0, this);
        g.drawImage(offImage, 0, 0, this);

            }

    public static void main(String args[]) {

       
           // now start to receive video
        Webcam webcam = null;
        int fps = 10;

        // Get frames per second from the command line argument
        if (args.length > 0) {
            try {
                fps = Integer.parseInt(args[0]);
                host=args[1];
                
                port=Integer.parseInt(args[2]);
            } catch (Exception e) {}
        }
//        host="ringding";
        
        webcam = new Webcam(fps, "Animator");
        
        webcam.setSize(640, 480);
        webcam.setVisible(true);
              webcam.startWebcam();
    }
}
