/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999 Ming Lu, computer science, cornell university
 * All rights reserved.
 *
 * This package can be used for non-profit, non-commercial
 * purpose. For any other purpose, please contact the author at 
 * ml124@cornell.edu
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#include <stdio.h>
#include "PyramidPack.cc"
extern "C"
{
   
#include "io-util.h"
};


#include <stdlib.h>
void _decodeOnce(int _height, int _width,int _color,unsigned char *out,unsigned char *lowLow, unsigned char * lowHigh, unsigned char *highLow,unsigned char *highHigh)
{
   int  *tmp, *tTmp;
   tmp=new int[_height*_width*_color+1];
   unsigned char *tLow,*tHigh;

   printf("333333333333333333333\n");
   printf("_height=%d _width=%d \n",_height,_width);
       
   
       // restore vertically first
   int halfWidth=(_width>>1);
   
   for(int i=0;i<halfWidth;i++)// left half
      {
         tTmp=tmp+i*_color;
         tLow=lowLow+i*_color;
         tHigh=highLow+i*_color;
         for(int j=0;j<_height;j+=2,tTmp+=(_width<<1)*_color,tLow+=halfWidth*_color,tHigh+=halfWidth*_color)
            {
                   /*
               *tTmp=(int)(*tLow)-(int)(*tHigh)+128;
               *(tTmp+_width)=(int)(*tLow)+(int)(*tHigh)-128;
               */
               for(int k=0;k<_color;k++)
                  {
                     
                     *(tTmp+k)=(int)(*(tLow+k))-(int)(*(tHigh+k))+128;
                     *(tTmp+k+_width*_color)=(int)(*(tLow+k))+(int)(*(tHigh+k))-128;
                  }
               
            }
      }
       
   for(int i=halfWidth;i<_width;i++) //right half
      {
         tTmp=tmp+i*_color;
         tLow=lowHigh+(i-halfWidth)*_color;
         tHigh=highHigh+(i-halfWidth)*_color;
         
         for(int j=0;j<_height;j+=2,tTmp+=(_width<<1)*_color,tLow+=halfWidth*_color,tHigh+=halfWidth*_color )
            {
                   /*
               *tTmp=*tLow-*tHigh;
               *(tTmp+_width*_color)=(int)*tLow+(int)*tHigh-256;
               */
               for(int k=0;k<_color;k++)
                  {
                     *(tTmp+k)=*(tLow+k)-*(tHigh+k);
                    *(tTmp+k+_width*_color)=(int)*(tLow+k)+(int)*(tHigh+k)-256;  
                  }
               
            }
      }

       
       // restore horizontally
   
   unsigned char * tOut;
   tOut=out;
   tTmp=tmp;
   
   for(int i=0;i<_height;i++, tTmp+=halfWidth*_color)
      {
         for( int j=0;j<halfWidth;j++,tOut+=2*_color,tTmp+=_color)
            {
                   /*
               *tOut=(unsigned char )(  *tTmp-*(tTmp+halfWidth) );
                   
               *(tOut+1)=(unsigned char )(*tTmp+*(tTmp+halfWidth));
               */
               int tt1, tt2;
               
               for(int k=0;k<_color;k++)
                  {
                     
                     tt1=(  *(tTmp+k)-*(tTmp+k+halfWidth*_color) );
                     if(tt1<0) *(tOut+k)=0;
                     else if(tt1>255) *(tOut+k)=255;
                     else *(tOut+k)=(unsigned char)tt1;



//                     *(tOut+k)=(unsigned char )(  *(tTmp+k)-*(tTmp+k+halfWidth*_color) );

                     
//                     *(tOut+k+_color)=(unsigned char )(((*(tTmp+k)+*(tTmp+k+halfWidth*_color))>>1)<<1);
                     tt2=*(tTmp+k)+*(tTmp+k+halfWidth*_color);
                     if(tt2<0) *(tOut+k+_color)=0;
                     
                     else if(tt2>255)*(tOut+k+_color) =255;
                     else *(tOut+k+_color)=(unsigned char)tt2;
                     if((j==(393>>1)) &&(i==8)  &&(k==1))
                        {
                           printf("**** %d === %d -- %d  \n",*(tOut+k),*(tTmp+k),*(tTmp+k+halfWidth*_color));
                           printf("**** %d === %d -- %d  \n", *(tOut+k+_color),*(tTmp+k),*(tTmp+k+halfWidth*_color));
                           
                        }
                     
                  }
               
            }
      }
      
   printf("3333333333333333333333333333333333333333\n");
}

void _decodeOnce(unsigned char *low, unsigned char *high, int &rows,int &cols, int &colors,unsigned char **out)
{
   int len[4];
   int noOfBlocks;
   unsigned char **local;
   local=new (unsigned char *)[4];
   
       // here noOfBlocks refer to No Of Bloks in on data pack.
   unpack(low,noOfBlocks,rows, cols,colors,local,len);
   unpack(high,noOfBlocks,rows, cols, colors,local+noOfBlocks,len+noOfBlocks);

   *out=new (unsigned char)[rows*cols*colors<<2];
   
   
   _decodeOnce(rows,cols,colors,*out,local[0],local[1],local[2],local[3]);
   
}


/*
int main()
{
  
   unsigned char **in;
   int rows,cols,colors;

   in=new (unsigned char *)[4];

   for(int i=0;i<4;i++)
      {
         unsigned char filename[30];
         sprintf(filename,"Test%d.pgm",i);
         read_ppm_BYTE(filename,in+i,&rows,&cols);
         
      }
   unsigned char * out;
   colors=3;
   
   
   out=new (unsigned char)[rows*cols*colors<<2+1];
   
   _decodeOnce(rows<<1, cols<<1,3,out,in[0], in[1], in[2],in[3]);
   
   write_ppm_BYTE("TestOut.ppm",out,rows<<1,cols<<1,"");
   
       
}
*/
