#include <stdio.h>

extern "C"
{
#include "io-util.h"
};
#include "PyramidEncoder.h"

void _encodeOnce(int _height, int _width,int _color,unsigned char *src,unsigned char *lowLow, unsigned char * lowHigh, unsigned char *highLow,unsigned char *highHigh, int *length)
{
   unsigned char *tSrc;
   int *tmp,*tmpHead, *tLow,*tHigh;
   int halfWidth=_width>>1;
   int size=_width*_height*_color;
   
   tmp=new int[size+1];
   tSrc=src;
   tmpHead=tmp;
       //do it horizontally
   for(int i=0;i<_height;i++,tmpHead+=_width*_color)
      {
         tLow=tmpHead;
         tHigh=tmpHead+ halfWidth*_color;
         
         for(int j=0;j<_width;j+=2,tSrc+=2*_color,tLow+=_color,tHigh+=_color)
            {
/*               *tLow =((int)(*tSrc+*(tSrc+1)))>>1;
 *tHigh=((int)(*(tSrc+1))-(int)(*tSrc))>>1;*/
               for(int k=0;k<_color;k++)
                  {
                     
                     *(tLow+k) =((int)(*(tSrc+k)+*(tSrc+k+_color)))>>1;
                     *(tHigh+k)=((int)(*(tSrc+k+_color))-(int)(*(tSrc+k)))>>1;    
                  }
               
            }
         
      }
   
       // do it vertically
   tmpHead=tmp;
   unsigned char  *tmpLowLow,*tmpLowHigh,*tmpHighLow,*tmpHighHigh;
   

       ///////////////////////////////////
       //               //              //
       //               //              //
       //     Low Low   //   Low High   //
       //               //              //
       ///////////////////////////////////
       //               //              //
       //               //              //
       //     High Low  //   High High  //
       //               //              //
       ///////////////////////////////////   
    
   

   int *t;
   unsigned char *tmpLow,*tmpHigh;
   
       // do low low and low high
   tmpLowLow=lowLow;
   tmpHighLow=highLow;
   t=tmp;
   for(int i=0;i<halfWidth;i++,tmpLowLow+=_color,tmpHighLow+=_color,t=tmp+i*_color)
      {
         tmpLow=tmpLowLow;
         tmpHigh=tmpHighLow;
         for(int j=0;j<_height;j+=2,tmpLow+=halfWidth*_color,tmpHigh+=halfWidth*_color,t+=(_width<<1)*_color)
            {/*
               *tmpLow=(unsigned char) ( (*t+*(t+_width))>>1);
               *tmpHigh=(unsigned char)((*(t+_width)-(*t)+256 )>>1 );
               */
               for(int k=0;k<_color;k++)
                  {
                     
                     *(tmpLow+k)=(unsigned char) ( (*(t+k)+*(t+k+_width*_color))>>1);
                     *(tmpHigh+k)=(unsigned char)((*(t+k+_width*_color)-(*(t+k))+256 )>>1 );
                  }
               
            }
         
      }
    // right half
   tmpLowHigh=lowHigh;
   tmpHighHigh=highHigh;
   t=tmp+halfWidth*_color;
   for(int i=halfWidth;i<_width;i++,tmpLowHigh+=_color,tmpHighHigh+=_color,t=tmp+i*_color)
      {
         tmpLow=tmpLowHigh;
         tmpHigh=tmpHighHigh;
         
         for(int j=0;j<_height;j+=2,tmpLow+=halfWidth*_color,tmpHigh+=halfWidth*_color,t+=(_width<<1)*_color)
            {
                   /*
                    *tmpLow=(unsigned char ) ( ( *t+ *(t+_width)  +256)>>1);
                    *tmpHigh=(unsigned char)( (*(t+_width)-(*t)+256)>>1);
                    */
               for(int k=0;k<_color;k++)
                  {
                     
                     *(tmpLow+k)=(unsigned char ) ( ( *(t+k)+ *(t+k+_width*_color)  +256)>>1);
                     *(tmpHigh+k)=(unsigned char)( (*(t+k+_width*_color)-(*(t+k))+256)>>1);
                  }
               
            }
    }
   
   for(int i=0;i<4;i++)
      length[i]=size>>2;
   lowLow[size>>2]='\0';
   lowHigh[size>>2]='\0';
   highLow[size>>2]='\0';
   highHigh[size>>2]='\0';
   
   printf(" len[0]=%d len[1]=%d len[2]=%d len[3]=%d \n",length[0],length[1],length[2],length[3]);
   
}


void _encodeOnce(unsigned char *src, int height,int width,int colors,struct _PyramidInfo *low,struct _PyramidInfo *high)
{int length[4];
   unsigned char *tmp[4];
   for(int i=0;i<4;i++)
      tmp[i]=new (unsigned char)[width*height*colors>>2+1];
   _encodeOnce(height,width,colors,src,tmp[0],tmp[1],tmp[2],tmp[3],length);
   low->width=width;
   low->height=height;
   low->colors=colors;
   low->noOfBlocks=1;
   low->length=length[0];
   low->len[0]=length[0];
   
   low->data=tmp[0];
   
   high->width=width;
   high->height=height;
   high->colors=colors;
   high->noOfBlocks=3;
   high->length=length[1]+length[2]+length[3];
   for(int i=0;i<3;i++)
      high->len[i]=length[i+1];
   high->data=new (unsigned char)[high->length+1];
   unsigned char *t;
   t=high->data;
   for(int i=0;i<3;i++)
      {
         memcpy(t,tmp[i+1],length[i+1]);
         t+=length[i+1];
      }
   *(high->data+high->length)='\0';

   
}



int main()
{
   int width=160;
   int height=120;
   int colors=3;
   unsigned char *image=new (unsigned char)[width*height*colors+1];
   
   int t=0;
   
    for(int i=0;i<height;i++)
       for(int j=0;j<width;j++)
          for(int k=0;k<3;k++)
             {
                if(j<40)
                   {
                      if(k==0) *(image+t)=255;
                      else *(image+t)=0;
                   }
                
                if(j<80)
                   {
                      if(k==1) *(image+t)=255;
                      else *(image+t)=0;
                   }
                else
                   {
                      if(k==2) *(image+t)=255;
                      else *(image+t)=0;
                   }
                t++;
             }     

    struct _PyramidInfo *   info=new (struct _PyramidInfo)[2];
    _encodeOnce(image,height,width,colors,&info[0],&info[1]);
    
}









