/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999 Ming Lu, computer science, cornell university
 * All rights reserved.
 *
 * This package can be used for non-profit, non-commercial
 * purpose. For any other purpose, please contact the author at 
 * ml124@cornell.edu
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * *  
 *    Author : Ming Lu
 *    E-mail : ml124@cornell.edu
 *
 *    static char *const RCSId ="  $Id ";
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#include "socket.h"

Socket::Socket()
{

   if ((socketFD = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
      perror("socket");
      exit(1);
   }
   
   
   stringSendLength=0;
   stringReadLength=0;
   
}


Socket::Socket(const Socket &socket)
{
   socketFD=socket.socketFD;

   stringSend=new char[stringSendLength=socket.stringSendLength];
   for(int i=0;i<stringSendLength;i++) stringSend[i]=socket.stringSend[i];
   
   stringRead=new char[stringReadLength=socket.stringReadLength];
   for(int i=0;i<stringReadLength;i++) stringRead[i]=socket.stringRead[i];
   
}
Socket & Socket::operator=(const Socket &socket)
{
   if (this!=&socket)
      {
         socketFD=socket.socketFD;
         
         delete[] stringSend;
         stringSend=new char[stringSendLength=socket.stringSendLength];
         for(int i=0;i<stringSendLength;i++) stringSend[i]=socket.stringSend[i];
         
         delete[] stringRead;
         stringRead=new char[stringReadLength=socket.stringReadLength];
         for(int i=0;i<stringReadLength;i++) stringRead[i]=socket.stringRead[i];
      }
   return *this;
   
}
int Socket::readString(int socketID,char *string,int len)
{
   
   return recv(socketID,string,(len>BUFFERSIZE)?BUFFERSIZE:len,0);
}

int Socket::readString(int socketID,char *string)
{

stringReadLength=recv(socketID,string,BUFFERSIZE,0);
   if (stringReadLength!=-1) 
      {
         return stringReadLength;
      }
   
   else
      {
         perror("recv");
         return -1;
      }
   
}



Socket::~Socket()
{
   close(socketFD);
}
   
int  Socket::sendString(int socketNumber,char *stringSend,int stringSendLength)
{
 int byteSent;
 int left=stringSendLength;
 int size;
 int totalSent=0;
    do
      {
         if(left>BUFFERSIZE) size=BUFFERSIZE;
         else size=left;
         byteSent=send(socketNumber, stringSend+totalSent, size, 0);
         if(byteSent>0)
            {
               left-=byteSent;
               totalSent+=byteSent;
            }
      }
    while (totalSent<stringSendLength);
    return stringSendLength;
}


