/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999 Ming Lu, computer science, cornell university
 * All rights reserved.
 *
 * This package can be used for non-profit, non-commercial
 * purpose. For any other purpose, please contact the author at 
 * ml124@cornell.edu
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * *  
 *    Author : Ming Lu
 *    E-mail : ml124@cornell.edu
 *
 *    static char *const RCSId ="  $Id ";
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */  


#ifndef Socket_H
#define Socket_H

extern "C" 
{
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>
#include <netdb.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
}

#define BUFFERSIZE 1200 
class Socket
{
public:
   Socket();
   Socket(const Socket &socket);
   Socket &operator=(const Socket &socket);
   
   virtual int readString(char *stringRead)=0;
   virtual int readString(char *stringRead, int len)=0;
   virtual int sendString(char *stringSend, int stringSendLength)=0;
   
   virtual ~Socket();


   
protected:

   int  sendString(int socketID,char *stringSend,int stringSendLength);
   int readString(int socketID,char *string,int len);
   int readString(int socketID,char *stringRead);
   
   
   int socketFD;
   
   int stringReadLength;
   char *stringRead;
   
   int stringSendLength;
   char *stringSend;   
 
};



#endif


