/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Copyright (c) 1999 Ming Lu, computer science, cornell university
 * All rights reserved.
 *
 * This package can be used for non-profit, non-commercial
 * purpose. For any other purpose, please contact the author at 
 * ml124@cornell.edu
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */


/*
 *    static char *const RCSId ="  $Id ";
 */

#include "socketClient.h"

SocketClient::SocketClient()
{
   serverPortNumber=-1;
   serverName=new char[1];
   strcpy(serverName,"\0");
}

SocketClient::SocketClient(char *nameOfServer,int portNumberOfServer)
{
   struct hostent *he;
   struct sockaddr_in their_addr; /* connector's address information */
   serverName=new char[strlen(nameOfServer)+1];
   
   strcpy(serverName,nameOfServer);
   serverPortNumber=portNumberOfServer;
   
   
   if ((he=gethostbyname(serverName)) == NULL) {  /* get the host info */
      perror("gethostbyname");
      exit(1);
   }
   
   their_addr.sin_family = AF_INET;         /* host byte order */
   their_addr.sin_port = htons(serverPortNumber);     /* short, network byte order */
   their_addr.sin_addr = *((struct in_addr *)he->h_addr);
   bzero(&(their_addr.sin_zero), 8);        /* zero the rest of the struct */
   
   if (connect(socketFD, (struct sockaddr *)&their_addr, sizeof(struct sockaddr))
       == -1) {
      perror("connect");
   }
   stringRead=new char[BUFFERSIZE+1];
   
}


SocketClient::SocketClient(const SocketClient &socketClient)
{
   socketFD=socketClient.socketFD;
   
   int tmpStringLength;
   serverName=new char[tmpStringLength=strlen(socketClient.serverName)];
   for(int i=0;i<tmpStringLength;i++)
      serverName[i]=socketClient.serverName[i];
}

SocketClient& SocketClient::operator=(const SocketClient &socketClient)
{
   int tmpStringLength;
   if (this != &socketClient)
      {
         socketFD=socketClient.socketFD;

         delete[] serverName;
         serverName=new char[tmpStringLength=strlen(socketClient.serverName)];
         for(int i=0;i<tmpStringLength;i++)
            serverName[i]=socketClient.serverName[i];
      }
   return *this;
}



void SocketClient::requestService(char * request, int requestLength, char *replay, int &replayLength)
{
   sendString(request,requestLength);
   replayLength=readString(replay);
   
  
      
}





int SocketClient::close()
{
   ::close(socketFD);
   
}
int SocketClient::sendString(char *stringSend, int stringSendLength)
{
   return Socket::sendString(socketFD,stringSend,stringSendLength);
   
}

int SocketClient::readString(char * stringRead, int len)
{
   return Socket::readString(socketFD,stringRead,len);
   
}

int SocketClient::readString(char * stringRead)
{
   return Socket::readString(socketFD,stringRead);
}
